(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/common/http'), require('rxjs'), require('rxjs/operators'), require('@angular/forms'), require('oidc-client'), require('jwt-decode'), require('@angular/core/testing')) :
    typeof define === 'function' && define.amd ? define('totvs-log-base-foundation', ['exports', '@angular/common', '@angular/core', '@angular/common/http', 'rxjs', 'rxjs/operators', '@angular/forms', 'oidc-client', 'jwt-decode', '@angular/core/testing'], factory) :
    (global = global || self, factory(global['totvs-log-base-foundation'] = {}, global.ng.common, global.ng.core, global.ng.common.http, global.rxjs, global.rxjs.operators, global.ng.forms, global.oidcClient, global.jwtDecode_, global.ng.core.testing));
}(this, function (exports, common, core, http, rxjs, operators, forms, oidcClient, jwtDecode_, testing) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var EOData = {
        Equals: 0,
        NotEquals: 1,
        GreaterThan: 2,
        GreaterThanOrEquals: 3,
        LessThan: 4,
        LessThanOrEquals: 5,
        Flag: 6,
        Contains: 7,
        EndsWith: 8,
        StartsWith: 9,
        Length: 10,
        IndexOf: 11,
        SubString: 12,
        ToLower: 13,
        ToUpper: 14,
        Trim: 15,
        ConCat: 16,
        Year: 17,
        Month: 18,
        Day: 19,
        Hour: 20,
        Minute: 21,
        Second: 22,
        Date: 23,
        Time: 24,
        TotalOffSetMinutes: 25,
        Now: 26,
        MinDateTime: 27,
        MaxDateTime: 28,
        Round: 29,
        Floor: 30,
        Ceiling: 31,
        Cast: 32,
        IsOf: 33,
        And: 34,
        Or: 35,
        Not: 36,
        Null: 37,
    };
    EOData[EOData.Equals] = 'Equals';
    EOData[EOData.NotEquals] = 'NotEquals';
    EOData[EOData.GreaterThan] = 'GreaterThan';
    EOData[EOData.GreaterThanOrEquals] = 'GreaterThanOrEquals';
    EOData[EOData.LessThan] = 'LessThan';
    EOData[EOData.LessThanOrEquals] = 'LessThanOrEquals';
    EOData[EOData.Flag] = 'Flag';
    EOData[EOData.Contains] = 'Contains';
    EOData[EOData.EndsWith] = 'EndsWith';
    EOData[EOData.StartsWith] = 'StartsWith';
    EOData[EOData.Length] = 'Length';
    EOData[EOData.IndexOf] = 'IndexOf';
    EOData[EOData.SubString] = 'SubString';
    EOData[EOData.ToLower] = 'ToLower';
    EOData[EOData.ToUpper] = 'ToUpper';
    EOData[EOData.Trim] = 'Trim';
    EOData[EOData.ConCat] = 'ConCat';
    EOData[EOData.Year] = 'Year';
    EOData[EOData.Month] = 'Month';
    EOData[EOData.Day] = 'Day';
    EOData[EOData.Hour] = 'Hour';
    EOData[EOData.Minute] = 'Minute';
    EOData[EOData.Second] = 'Second';
    EOData[EOData.Date] = 'Date';
    EOData[EOData.Time] = 'Time';
    EOData[EOData.TotalOffSetMinutes] = 'TotalOffSetMinutes';
    EOData[EOData.Now] = 'Now';
    EOData[EOData.MinDateTime] = 'MinDateTime';
    EOData[EOData.MaxDateTime] = 'MaxDateTime';
    EOData[EOData.Round] = 'Round';
    EOData[EOData.Floor] = 'Floor';
    EOData[EOData.Ceiling] = 'Ceiling';
    EOData[EOData.Cast] = 'Cast';
    EOData[EOData.IsOf] = 'IsOf';
    EOData[EOData.And] = 'And';
    EOData[EOData.Or] = 'Or';
    EOData[EOData.Not] = 'Not';
    EOData[EOData.Null] = 'Null';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe que representa o operador odata or
     * Deve ser apenas instanciado pelo Odata.Or()
     */
    var   /**
     * Classe que representa o operador odata or
     * Deve ser apenas instanciado pelo Odata.Or()
     */
    ODataOr = /** @class */ (function () {
        /**
         * Construtor
         */
        function ODataOr(left, right) {
            this.left = left;
            this.right = right;
            /**
             * Operador lógico ||
             */
            this.operator = EOData.Or;
        }
        /**
         * Retorna a string Odata
         */
        /**
         * Retorna a string Odata
         * @return {?}
         */
        ODataOr.prototype.toString = /**
         * Retorna a string Odata
         * @return {?}
         */
        function () {
            return '(' + this.left.toString() + ' or ' + this.right.toString() + ')';
        };
        return ODataOr;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe que representa o operador odata not
     * Deve ser apenas instanciado pelo Odata.not()
     */
    var   /**
     * Classe que representa o operador odata not
     * Deve ser apenas instanciado pelo Odata.not()
     */
    ODataNot = /** @class */ (function () {
        /**
         * Construtor
         */
        function ODataNot(odataExpression) {
            this.odataExpression = odataExpression;
            /**
             * Operador lógico !
             */
            this.operator = EOData.Not;
        }
        /**
         * Retorna a string Odata
         */
        /**
         * Retorna a string Odata
         * @return {?}
         */
        ODataNot.prototype.toString = /**
         * Retorna a string Odata
         * @return {?}
         */
        function () {
            return 'not (' + this.odataExpression.toString() + ')';
        };
        return ODataNot;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe que representa o operador odata and
     * Deve ser apenas instanciado pelo Odata.And()
     */
    var   /**
     * Classe que representa o operador odata and
     * Deve ser apenas instanciado pelo Odata.And()
     */
    ODataAnd = /** @class */ (function () {
        /**
         * Construtor
         */
        function ODataAnd(left, right) {
            this.left = left;
            this.right = right;
            /**
             * Operador lógico &&
             */
            this.operator = EOData.And;
        }
        /**
         * Retorna a string Odata
         */
        /**
         * Retorna a string Odata
         * @return {?}
         */
        ODataAnd.prototype.toString = /**
         * Retorna a string Odata
         * @return {?}
         */
        function () {
            return '(' + this.left.toString() + ' and ' + this.right.toString() + ')';
        };
        return ODataAnd;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var QueryFilter = /** @class */ (function () {
        function QueryFilter() {
            /**
             * query: array que contém os dados de filtro
             */
            this.query = [];
        }
        /**
         * @param {...?} o
         * @return {?}
         */
        QueryFilter.Build = /**
         * @param {...?} o
         * @return {?}
         */
        function () {
            var o = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                o[_i] = arguments[_i];
            }
            /** @type {?} */
            var filter = new QueryFilter();
            filter.add.apply(filter, __spread(o));
            return filter;
        };
        Object.defineProperty(QueryFilter.prototype, "length", {
            /**
             * método que retorna o tamanho do array/campo query
             */
            get: /**
             * método que retorna o tamanho do array/campo query
             * @return {?}
             */
            function () {
                return this.query.length;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * método que adiciona na query os objetos com informações de filtro
         * @param o array com os dados de filtro
         */
        /**
         * método que adiciona na query os objetos com informações de filtro
         * @param {...?} o array com os dados de filtro
         * @return {?}
         */
        QueryFilter.prototype.add = /**
         * método que adiciona na query os objetos com informações de filtro
         * @param {...?} o array com os dados de filtro
         * @return {?}
         */
        function () {
            var _this = this;
            var o = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                o[_i] = arguments[_i];
            }
            o.forEach((/**
             * @param {?} element
             * @return {?}
             */
            function (element) {
                _this.query.push(element);
            }));
        };
        /**
         * método que adiciona um agrupador de lógica ( parenteses ) na última
         * expressão ou na próxima que for adicionada
         */
        /**
         * método que adiciona um agrupador de lógica ( parenteses ) na última
         * expressão ou na próxima que for adicionada
         * @param {?=} previous
         * @return {?}
         */
        QueryFilter.prototype.addGroup = /**
         * método que adiciona um agrupador de lógica ( parenteses ) na última
         * expressão ou na próxima que for adicionada
         * @param {?=} previous
         * @return {?}
         */
        function (previous) {
        };
        /**
         * Implementar de forma a compor o filtro com os dados recebidos
         */
        /**
         * Implementar de forma a compor o filtro com os dados recebidos
         * @param {?} params
         * @return {?}
         */
        QueryFilter.prototype.updateParams = /**
         * Implementar de forma a compor o filtro com os dados recebidos
         * @param {?} params
         * @return {?}
         */
        function (params) {
            this.query.forEach((/**
             * @param {?} e
             * @return {?}
             */
            function (e) { return params = params.append(e.field, e.value.toString()); }));
            return params;
        };
        return QueryFilter;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe que representa um chave/valor
     */
    var   /**
     * Classe que representa um chave/valor
     */
    FieldValue = /** @class */ (function () {
        function FieldValue(field, value) {
            this.field = field;
            this.value = value;
        }
        return FieldValue;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var ApiOrderType = {
        OrderAsc: 0,
        OrderDesc: 1,
    };
    ApiOrderType[ApiOrderType.OrderAsc] = 'OrderAsc';
    ApiOrderType[ApiOrderType.OrderDesc] = 'OrderDesc';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe específica para tratar erros críticos do sistema
     */
    var   /**
     * Classe específica para tratar erros críticos do sistema
     */
    CriticalError = /** @class */ (function (_super) {
        __extends(CriticalError, _super);
        /**
         * Método construtor que inicializa a classe
         */
        function CriticalError(internalError, objectData) {
            var _this = _super.call(this, internalError.toString()) || this;
            console.error(internalError);
            if (objectData) {
                console.log(JSON.stringify(objectData));
            }
            return _this;
        }
        return CriticalError;
    }(Error));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Representação do campo, contendo seu nome e o tipo de ordenação
     */
    var   /**
     * Representação do campo, contendo seu nome e o tipo de ordenação
     */
    ApiOrderField = /** @class */ (function () {
        /**
         * Método contrutor da classe
         */
        function ApiOrderField(field) {
            if (!field || field.length === 0) {
                throw new CriticalError("Atributo field n\u00E3o pode estar vazio.", this);
            }
            this.field = field;
            this.orderType = ApiOrderType.OrderAsc;
        }
        /**
         * Retorna a string formatada do campo, já contendo o sinal apropriado a seu tipo de ordenação
         */
        /**
         * Retorna a string formatada do campo, já contendo o sinal apropriado a seu tipo de ordenação
         * @return {?}
         */
        ApiOrderField.prototype.toString = /**
         * Retorna a string formatada do campo, já contendo o sinal apropriado a seu tipo de ordenação
         * @return {?}
         */
        function () {
            /** @type {?} */
            var order = this.orderType === ApiOrderType.OrderAsc ? '+' : '-';
            return "" + order + this.field;
        };
        /**
         * Seta a ordem do campo como ascendente
         */
        /**
         * Seta a ordem do campo como ascendente
         * @return {?}
         */
        ApiOrderField.prototype.Asc = /**
         * Seta a ordem do campo como ascendente
         * @return {?}
         */
        function () {
            this.orderType = ApiOrderType.OrderAsc;
            return this;
        };
        /**
         * Seta a ordem do campo como descendente
         */
        /**
         * Seta a ordem do campo como descendente
         * @return {?}
         */
        ApiOrderField.prototype.Desc = /**
         * Seta a ordem do campo como descendente
         * @return {?}
         */
        function () {
            this.orderType = ApiOrderType.OrderDesc;
            return this;
        };
        return ApiOrderField;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe com as constantes definidas de data e hora
     */
    var ApiDateTimeConstants = /** @class */ (function () {
        function ApiDateTimeConstants() {
        }
        /**
         * formato de data padrão
         */
        ApiDateTimeConstants.DATE_FORMAT = 'yyyy-MM-dd';
        /**
         * formato de exibição de data em português
         */
        ApiDateTimeConstants.DATE_FORMAT_DISPLAY_PT = 'dd/MM/yyyy';
        /**
         * formato de exibição de data em inglês
         */
        ApiDateTimeConstants.DATE_FORMAT_DISPLAY_EN = 'MM/dd/yyyy';
        /**
         * formato de exibição padrão de hora, minuto e segundo
         */
        ApiDateTimeConstants.TIME_FORMAT = 'HH:mm:ss';
        /**
         * formato de exibição padrão de fuso horário
         */
        ApiDateTimeConstants.TIMEZONE_FORMAT = 'ZZZZZ';
        /**
         * Linguagem padrão
         */
        ApiDateTimeConstants.LANG_DEFAULT = 'en-US';
        return ApiDateTimeConstants;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe do serviço de formatação de data e hora de acordo com o guia de implementação de API
     */
    var ApiDateTimeService = /** @class */ (function () {
        /**
         * Método construtor da classe
         */
        function ApiDateTimeService(datePipe) {
            this.datePipe = datePipe;
        }
        /**
         * Retorna data no formato especificado pelo Guia de Implementação de API
         * Formato: data (E8601DAw.): yyyy-mm-dd
         */
        /**
         * Retorna data no formato especificado pelo Guia de Implementação de API
         * Formato: data (E8601DAw.): yyyy-mm-dd
         * @param {?} value
         * @return {?}
         */
        ApiDateTimeService.prototype.dateFormatAPI = /**
         * Retorna data no formato especificado pelo Guia de Implementação de API
         * Formato: data (E8601DAw.): yyyy-mm-dd
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return this.datePipe.transform(value, ApiDateTimeConstants.DATE_FORMAT);
        };
        /** Retorna data no formato extendido especificado pelo Guia de Implementação de API
         *  Formato: data UTC estendido (E8601DZw.d): yyyy-mm-ddThh:mm:ss.nnnnnn+|-hh:mm   (+|-hh:mm = timezone/fuso)
         */
        /**
         * Retorna data no formato extendido especificado pelo Guia de Implementação de API
         *  Formato: data UTC estendido (E8601DZw.d): yyyy-mm-ddThh:mm:ss.nnnnnn+|-hh:mm   (+|-hh:mm = timezone/fuso)
         * @param {?} value
         * @return {?}
         */
        ApiDateTimeService.prototype.dateFormatExtendAPI = /**
         * Retorna data no formato extendido especificado pelo Guia de Implementação de API
         *  Formato: data UTC estendido (E8601DZw.d): yyyy-mm-ddThh:mm:ss.nnnnnn+|-hh:mm   (+|-hh:mm = timezone/fuso)
         * @param {?} value
         * @return {?}
         */
        function (value) {
            /** @type {?} */
            var result = this.dateFormatAPI(value) + 'T' +
                this.datePipe.transform(value, ApiDateTimeConstants.TIME_FORMAT) +
                this.datePipe.transform(value, ApiDateTimeConstants.TIMEZONE_FORMAT);
            return result;
        };
        /**
         * Retorna hora no formato especificado pelo Guia de Implementação de API
         * Hora (E8601TMw.d): hh:mm:ss.ffffff   (f = milisegundos)
         */
        /**
         * Retorna hora no formato especificado pelo Guia de Implementação de API
         * Hora (E8601TMw.d): hh:mm:ss.ffffff   (f = milisegundos)
         * @param {?} value
         * @return {?}
         */
        ApiDateTimeService.prototype.timeFormatAPI = /**
         * Retorna hora no formato especificado pelo Guia de Implementação de API
         * Hora (E8601TMw.d): hh:mm:ss.ffffff   (f = milisegundos)
         * @param {?} value
         * @return {?}
         */
        function (value) {
            /** @type {?} */
            var dateMilliseconds = new Date(value)
                .getMilliseconds()
                .toPrecision(6)
                .replace('.', '');
            /** Retorna no formato do guia de implementação de API para hora:  hh:mm:ss.ffffff */
            return this.datePipe.transform(value, ApiDateTimeConstants.TIME_FORMAT) + "." + dateMilliseconds + " ";
        };
        ApiDateTimeService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        ApiDateTimeService.ctorParameters = function () { return [
            { type: common.DatePipe }
        ]; };
        return ApiDateTimeService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe que implementa as operações de filtro
     */
    var   /**
     * Classe que implementa as operações de filtro
     */
    OData = /** @class */ (function () {
        /**
         * Método construtor que inicializa o objeto
         */
        function OData(data) {
            if (data === void 0) { data = { field: '', value: '', operator: EOData.Equals }; }
            if (data == null) {
                this.operator = EOData.Null;
            }
            else {
                if ((!data.field || data.field.length === 0) && data.operator !== EOData.And && data.operator !== EOData.Or) {
                    throw new CriticalError("Atributo field n\u00E3o pode estar vazio.", data);
                }
                this.field = data.field;
                this.value = data.value;
                this.operator = data.operator;
            }
        }
        /**
         * Fábrica estática que retorna um odata do tipo Null
         */
        /**
         * Fábrica estática que retorna um odata do tipo Null
         * @return {?}
         */
        OData.Null = /**
         * Fábrica estática que retorna um odata do tipo Null
         * @return {?}
         */
        function () {
            return new OData(null);
        };
        /**
         * Fábrica estática que retorna um odata do tipo Equals
         */
        /**
         * Fábrica estática que retorna um odata do tipo Equals
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        OData.Equals = /**
         * Fábrica estática que retorna um odata do tipo Equals
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        function (field, value) {
            return new OData({
                field: field,
                value: value,
                operator: EOData.Equals
            });
        };
        /**
         * Fábrica estática que retorna um odata do tipo NotEquals
         */
        /**
         * Fábrica estática que retorna um odata do tipo NotEquals
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        OData.NotEquals = /**
         * Fábrica estática que retorna um odata do tipo NotEquals
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        function (field, value) {
            return new OData({
                field: field,
                value: value,
                operator: EOData.NotEquals
            });
        };
        /**
         * Fábrica estática que retorna um odata do tipo GreaterThan
         */
        /**
         * Fábrica estática que retorna um odata do tipo GreaterThan
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        OData.GreaterThan = /**
         * Fábrica estática que retorna um odata do tipo GreaterThan
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        function (field, value) {
            return new OData({
                field: field,
                value: value,
                operator: EOData.GreaterThan
            });
        };
        /**
         * Fábrica estática que retorna um odata do tipo GreaterThanOrEquals
         */
        /**
         * Fábrica estática que retorna um odata do tipo GreaterThanOrEquals
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        OData.GreaterThanOrEquals = /**
         * Fábrica estática que retorna um odata do tipo GreaterThanOrEquals
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        function (field, value) {
            return new OData({
                field: field,
                value: value,
                operator: EOData.GreaterThanOrEquals
            });
        };
        /**
         * Fábrica estática que retorna um odata do tipo LessThan
         */
        /**
         * Fábrica estática que retorna um odata do tipo LessThan
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        OData.LessThan = /**
         * Fábrica estática que retorna um odata do tipo LessThan
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        function (field, value) {
            return new OData({
                field: field,
                value: value,
                operator: EOData.LessThan
            });
        };
        /**
         * Fábrica estática que retorna um odata do tipo LessThanOrEquals
         */
        /**
         * Fábrica estática que retorna um odata do tipo LessThanOrEquals
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        OData.LessThanOrEquals = /**
         * Fábrica estática que retorna um odata do tipo LessThanOrEquals
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        function (field, value) {
            return new OData({
                field: field,
                value: value,
                operator: EOData.LessThanOrEquals
            });
        };
        /**
         * Fábrica estática que retorna um odata do tipo Contains
         */
        /**
         * Fábrica estática que retorna um odata do tipo Contains
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        OData.Contains = /**
         * Fábrica estática que retorna um odata do tipo Contains
         * @param {?} field
         * @param {?} value
         * @return {?}
         */
        function (field, value) {
            return new OData({
                field: field,
                value: value,
                operator: EOData.Contains
            });
        };
        /**
         * Fábrica estática que retorna um odata para o operador lógico E
         */
        /**
         * Fábrica estática que retorna um odata para o operador lógico E
         * @param {?} left
         * @param {?} right
         * @return {?}
         */
        OData.And = /**
         * Fábrica estática que retorna um odata para o operador lógico E
         * @param {?} left
         * @param {?} right
         * @return {?}
         */
        function (left, right) {
            return new ODataAnd(left, right);
        };
        /**
         * Fábrica estática que retorna um odata para o operador lógico Ou
         */
        /**
         * Fábrica estática que retorna um odata para o operador lógico Ou
         * @param {?} left
         * @param {?} right
         * @return {?}
         */
        OData.Or = /**
         * Fábrica estática que retorna um odata para o operador lógico Ou
         * @param {?} left
         * @param {?} right
         * @return {?}
         */
        function (left, right) {
            return new ODataOr(left, right);
        };
        /**
         * Fábrica estática que retorna um odata para o operador lógico Not
         */
        /**
         * Fábrica estática que retorna um odata para o operador lógico Not
         * @param {?} oDataExpression
         * @return {?}
         */
        OData.Not = /**
         * Fábrica estática que retorna um odata para o operador lógico Not
         * @param {?} oDataExpression
         * @return {?}
         */
        function (oDataExpression) {
            return new ODataNot(oDataExpression);
        };
        /**
         * método que trata o filtro solicitado pelo usuário, passando para o
         * formato string
         */
        /**
         * método que trata o filtro solicitado pelo usuário, passando para o
         * formato string
         * @return {?}
         */
        OData.prototype.toString = /**
         * método que trata o filtro solicitado pelo usuário, passando para o
         * formato string
         * @return {?}
         */
        function () {
            /** @type {?} */
            var filter;
            /** @type {?} */
            var value = this.value !== undefined ? this.value : 'null';
            if (typeof value === 'string') {
                if (value !== 'null') {
                    value = this.filterPaser(value);
                    value = "'" + value + "'";
                }
            }
            else {
                try {
                    value = this.value.toString();
                }
                catch (e) {
                    throw new CriticalError('Valor informado é inválido.', (/** @type {?} */ (value)));
                }
            }
            switch (+this.operator) {
                case EOData.Equals:
                    filter = this.field + " eq " + value;
                    break;
                case EOData.NotEquals:
                    filter = this.field + " ne " + value;
                    break;
                case EOData.GreaterThan:
                    filter = this.field + " gt " + value;
                    break;
                case EOData.GreaterThanOrEquals:
                    filter = this.field + " ge " + value;
                    break;
                case EOData.LessThan:
                    filter = this.field + " lt " + value;
                    break;
                case EOData.LessThanOrEquals:
                    filter = this.field + " le " + value;
                    break;
                case EOData.Contains:
                    filter = "contains(" + this.field + "," + value + ")";
                    break;
                case EOData.Null:
                    filter = '';
                    break;
                case EOData.And:
                case EOData.Or:
                case EOData.Not:
                case EOData.EndsWith:
                case EOData.StartsWith:
                case EOData.Length:
                case EOData.IndexOf:
                case EOData.SubString:
                case EOData.ToLower:
                case EOData.ToUpper:
                case EOData.Trim:
                case EOData.ConCat:
                case EOData.Year:
                case EOData.Month:
                case EOData.Day:
                case EOData.Hour:
                case EOData.Minute:
                case EOData.Second:
                case EOData.Date:
                case EOData.Time:
                case EOData.TotalOffSetMinutes:
                case EOData.Now:
                case EOData.MinDateTime:
                case EOData.MaxDateTime:
                case EOData.Round:
                case EOData.Floor:
                case EOData.Ceiling:
                case EOData.Cast:
                case EOData.IsOf:
                default:
                    throw new CriticalError("Flag n\u00E3o implementada.", this);
            }
            return filter;
        };
        /**
         * Função que faz o parser dos parâmetros de busca informados retirando
         * os caracteres especiais
         * @param filter filtro informado
         */
        /**
         * Função que faz o parser dos parâmetros de busca informados retirando
         * os caracteres especiais
         * @param {?} filter filtro informado
         * @return {?}
         */
        OData.prototype.filterPaser = /**
         * Função que faz o parser dos parâmetros de busca informados retirando
         * os caracteres especiais
         * @param {?} filter filtro informado
         * @return {?}
         */
        function (filter) {
            filter = filter.replace(new RegExp('[ÁÀÂÃ]', 'gi'), 'a');
            filter = filter.replace(new RegExp('[ÉÈÊ]', 'gi'), 'e');
            filter = filter.replace(new RegExp('[ÍÌÎ]', 'gi'), 'i');
            filter = filter.replace(new RegExp('[ÓÒÔÕ]', 'gi'), 'o');
            filter = filter.replace(new RegExp('[ÚÙÛ]', 'gi'), 'u');
            filter = filter.replace(new RegExp('[Ç]', 'gi'), 'c');
            return filter.toUpperCase();
        };
        return OData;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe que recebe os parâmetros solicitados para filtragem
     */
    var   /**
     * Classe que recebe os parâmetros solicitados para filtragem
     */
    ApiFilter = /** @class */ (function () {
        function ApiFilter() {
            /**
             * query: array que contém os dados de filtro
             */
            this.query = [];
        }
        Object.defineProperty(ApiFilter.prototype, "length", {
            /**
             * método que retorna o tamanho do array/campo query
             */
            get: /**
             * método que retorna o tamanho do array/campo query
             * @return {?}
             */
            function () {
                return this.query.length;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * método que adiciona na query os objetos com informações de filtro
         * @param o array com os dados de filtro
         */
        /**
         * método que adiciona na query os objetos com informações de filtro
         * @param {...?} o array com os dados de filtro
         * @return {?}
         */
        ApiFilter.prototype.add = /**
         * método que adiciona na query os objetos com informações de filtro
         * @param {...?} o array com os dados de filtro
         * @return {?}
         */
        function () {
            var e_1, _a;
            var o = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                o[_i] = arguments[_i];
            }
            /** @type {?} */
            var content = '';
            if (this.next === true) {
                content += '(';
            }
            try {
                for (var o_1 = __values(o), o_1_1 = o_1.next(); !o_1_1.done; o_1_1 = o_1.next()) {
                    var element = o_1_1.value;
                    if (element === undefined || element === null) {
                        element = OData.Null();
                    }
                    if (typeof element === 'string') {
                        content += element;
                    }
                    else {
                        content += element.toString();
                    }
                    content += ' ';
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (o_1_1 && !o_1_1.done && (_a = o_1.return)) _a.call(o_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            content = content.trim();
            if (this.next === true) {
                content += ')';
            }
            this.query.push(content);
            this.next = false;
        };
        /**
         * método que adiciona um agrupador de lógica ( parenteses ) na última
         * expressão ou na próxima que for adicionada
         */
        /**
         * método que adiciona um agrupador de lógica ( parenteses ) na última
         * expressão ou na próxima que for adicionada
         * @param {?=} previous
         * @return {?}
         */
        ApiFilter.prototype.addGroup = /**
         * método que adiciona um agrupador de lógica ( parenteses ) na última
         * expressão ou na próxima que for adicionada
         * @param {?=} previous
         * @return {?}
         */
        function (previous) {
            if (previous === void 0) { previous = true; }
            if (previous === true) {
                this.query[this.query.length - 1] = "(" + this.query[this.query.length - 1] + ")";
            }
            else {
                this.next = true;
            }
        };
        /**
         * método que retorna o objeto no formato string
         */
        /**
         * método que retorna o objeto no formato string
         * @return {?}
         */
        ApiFilter.prototype.toString = /**
         * método que retorna o objeto no formato string
         * @return {?}
         */
        function () {
            return this.query.join(' ');
        };
        return ApiFilter;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Esta classe define os métodos e atributos para consulta de dados
     */
    var   /**
     * Esta classe define os métodos e atributos para consulta de dados
     */
    ApiQueryString = /** @class */ (function () {
        /**
         * Método construtor que inicializa o objeto
         */
        function ApiQueryString(query) {
            if (query === void 0) { query = {
                page: 1,
                pageSize: 20,
                filter: undefined,
                expand: undefined,
                order: undefined,
                fields: undefined,
                query: undefined
            }; }
            this.page = query.page;
            this.pageSize = query.pageSize;
            this.filter = query.filter;
            this.expand = query.expand;
            this.fields = query.fields;
            this.order = query.order;
            this.query = query.query;
        }
        /**
         * Retorna os parâmetros de consulta(page, pageSize, filter, expand e fields) em formato string
         */
        /**
         * Retorna os parâmetros de consulta(page, pageSize, filter, expand e fields) em formato string
         * @return {?}
         */
        ApiQueryString.prototype.getQueryString = /**
         * Retorna os parâmetros de consulta(page, pageSize, filter, expand e fields) em formato string
         * @return {?}
         */
        function () {
            /** @type {?} */
            var pars = new http.HttpParams();
            if (this.page && this.page.toString()) {
                pars = pars.set('page', this.page.toString());
            }
            if (this.pageSize && this.pageSize.toString()) {
                pars = pars.set('pageSize', this.pageSize.toString());
            }
            if (this.filter && this.filter.toString()) {
                pars = pars.set('filter', this.filter.toString());
            }
            if (this.expand && this.expand.length > 0) {
                pars = pars.set('expand', this.expand.join(','));
            }
            if (this.order && this.order.toString()) {
                pars = pars.set('order', this.order.join(','));
            }
            if (this.fields && this.fields.length > 0) {
                pars = pars.set('fields', this.fields.join(','));
            }
            if (this.query && this.query.length > 0) {
                pars = this.query.updateParams(pars);
            }
            return pars;
        };
        return ApiQueryString;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe utilitária responsável por controlar a consulta de todos os registros de uma entidade
     * @template Entity, Dto
     */
    var   /**
     * Classe utilitária responsável por controlar a consulta de todos os registros de uma entidade
     * @template Entity, Dto
     */
    MappedGetAll = /** @class */ (function () {
        /**
         * Método construtor que inicializa a classe utilitária
         * @param httpClient Injeção do HttpClient
         * @param _urlGetAll URL completa do endpoint de GetAll
         * @param mapper Classe que determina o mapeamento da entidade
         */
        function MappedGetAll(httpClient, _urlGetAll, mapper) {
            this.httpClient = httpClient;
            this._urlGetAll = _urlGetAll;
            this.mapper = mapper;
            /**
             * Utilitário para manipular parâmetros query na requisição
             */
            this.apiQueryString = new ApiQueryString();
            /**
             * Array com os registros
             */
            this._items = [];
            /**
             * Indica se há mais registros
             */
            this._hasNext = false;
        }
        Object.defineProperty(MappedGetAll.prototype, "urlGetAll", {
            /** URL completa do endpoint de GetAll */
            get: /**
             * URL completa do endpoint de GetAll
             * @return {?}
             */
            function () {
                return this._urlGetAll;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MappedGetAll.prototype, "items", {
            get: /**
             * @return {?}
             */
            function () {
                return this._items;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MappedGetAll.prototype, "page", {
            /** Página corrente */
            get: /**
             * Página corrente
             * @return {?}
             */
            function () {
                return this.apiQueryString.page;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MappedGetAll.prototype, "pageSize", {
            get: /**
             * @return {?}
             */
            function () {
                return this.apiQueryString.pageSize;
            },
            /** Número de registros por página */
            set: /**
             * Número de registros por página
             * @param {?} _pageSize
             * @return {?}
             */
            function (_pageSize) {
                this.apiQueryString.pageSize = _pageSize;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MappedGetAll.prototype, "hasNext", {
            get: /**
             * @return {?}
             */
            function () {
                return this._hasNext;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MappedGetAll.prototype, "expands", {
            /** Expansões para a consulta */
            get: /**
             * Expansões para a consulta
             * @return {?}
             */
            function () {
                return this.apiQueryString.expand;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Método responsável por realizar a consulta dos registros
         * @return Retorno assíncrono dos registros buscados
         */
        /**
         * Método responsável por realizar a consulta dos registros
         * @return {?} Retorno assíncrono dos registros buscados
         */
        MappedGetAll.prototype.getAll = /**
         * Método responsável por realizar a consulta dos registros
         * @return {?} Retorno assíncrono dos registros buscados
         */
        function () {
            var _this = this;
            return this.httpClient.get(this.urlGetAll, { params: this.apiQueryString.getQueryString() }).pipe(operators.map((/**
             * @param {?} json
             * @return {?}
             */
            function (json) {
                /** @type {?} */
                var result = _this.mapper.MapTo(json);
                _this._hasNext = result.hasNext;
                _this._items = _this._items.concat(result.items);
                return _this._items;
            })));
        };
        /**
         * Método responsável por 'limpar' as parametrizações da consulta
         * e realizá-la novamente
         * @return Retorno assíncrono dos registros buscados
         */
        /**
         * Método responsável por 'limpar' as parametrizações da consulta
         * e realizá-la novamente
         * @param {?=} apiQueryString
         * @return {?} Retorno assíncrono dos registros buscados
         */
        MappedGetAll.prototype.reset = /**
         * Método responsável por 'limpar' as parametrizações da consulta
         * e realizá-la novamente
         * @param {?=} apiQueryString
         * @return {?} Retorno assíncrono dos registros buscados
         */
        function (apiQueryString) {
            var _this = this;
            this._hasNext = false;
            if (apiQueryString) {
                this.apiQueryString = apiQueryString;
            }
            this.apiQueryString.page = 1;
            return this.httpClient.get(this.urlGetAll, { params: this.apiQueryString.getQueryString() }).pipe(operators.map((/**
             * @param {?} json
             * @return {?}
             */
            function (json) {
                _this._items = [];
                /** @type {?} */
                var data = _this.mapper.MapTo(json);
                _this._hasNext = data.hasNext;
                _this._items = data.items;
                return _this._items;
            })));
        };
        /**
         * Método responsável por retornar os registros da próxima página
         * @return Retorno assíncrono dos registros buscados
         */
        /**
         * Método responsável por retornar os registros da próxima página
         * @return {?} Retorno assíncrono dos registros buscados
         */
        MappedGetAll.prototype.more = /**
         * Método responsável por retornar os registros da próxima página
         * @return {?} Retorno assíncrono dos registros buscados
         */
        function () {
            if (this.hasNext) {
                this.apiQueryString.page += 1;
                return this.getAll();
            }
            else {
                return rxjs.of([]);
            }
        };
        /**
         * Método responsável por definir os filtros por query que devem ser aplicados a consulta
         * @param queryFilter Classe que contém a definição dos filtros
         */
        /**
         * Método responsável por definir os filtros por query que devem ser aplicados a consulta
         * @param {?} queryFilter Classe que contém a definição dos filtros
         * @return {?}
         */
        MappedGetAll.prototype.setQueryFilter = /**
         * Método responsável por definir os filtros por query que devem ser aplicados a consulta
         * @param {?} queryFilter Classe que contém a definição dos filtros
         * @return {?}
         */
        function (queryFilter) {
            this.apiQueryString.query = queryFilter;
        };
        /**
         * Método responsável por definir as expansões para a consulta
         * @param expands Lista de expansões
         */
        /**
         * Método responsável por definir as expansões para a consulta
         * @param {...?} expands Lista de expansões
         * @return {?}
         */
        MappedGetAll.prototype.setExpands = /**
         * Método responsável por definir as expansões para a consulta
         * @param {...?} expands Lista de expansões
         * @return {?}
         */
        function () {
            var expands = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                expands[_i] = arguments[_i];
            }
            this.apiQueryString.expand = expands;
        };
        /**
         * Método responsável por 'limpar' as parametrizações da consulta e os itens
         */
        /**
         * Método responsável por 'limpar' as parametrizações da consulta e os itens
         * @return {?}
         */
        MappedGetAll.prototype.resetSearch = /**
         * Método responsável por 'limpar' as parametrizações da consulta e os itens
         * @return {?}
         */
        function () {
            this._items = [];
            this._hasNext = false;
            this.apiQueryString.page = 1;
        };
        return MappedGetAll;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Implementação da lista padrão de Dto
     * @template Dto
     */
    var   /**
     * Implementação da lista padrão de Dto
     * @template Dto
     */
    ListDto = /** @class */ (function () {
        function ListDto() {
            /**
             * A própria lista de itens
             */
            this.items = new Array();
        }
        return ListDto;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Mapper padrão para Dto
     * @template In, Out
     */
    var   /**
     * Mapper padrão para Dto
     * @template In, Out
     */
    ListDtoMapper = /** @class */ (function () {
        function ListDtoMapper(itemMapper) {
            this.itemMapper = itemMapper;
        }
        /**
         * Efetua o mapeando da lista de entidades
         * @param content Conteúdo do backend
         */
        /**
         * Efetua o mapeando da lista de entidades
         * @param {?} content Conteúdo do backend
         * @return {?}
         */
        ListDtoMapper.prototype.MapTo = /**
         * Efetua o mapeando da lista de entidades
         * @param {?} content Conteúdo do backend
         * @return {?}
         */
        function (content) {
            var _this = this;
            /** @type {?} */
            var result = new ListDto();
            result.hasNext = content.hasNext;
            content.items.forEach((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return result.items.push(_this.itemMapper.MapTo(item)); }));
            return result;
        };
        return ListDtoMapper;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Representa a resposta padrão em endpoints de criação
     */
    var   /**
     * Representa a resposta padrão em endpoints de criação
     */
    DefaultResponseDto = /** @class */ (function () {
        function DefaultResponseDto() {
        }
        return DefaultResponseDto;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe mapeadeadora de urls padrão
     * Atende o formato no template /entity/{0}/other/{1}
     */
    var   /**
     * Classe mapeadeadora de urls padrão
     * Atende o formato no template /entity/{0}/other/{1}
     */
    UrlMapper = /** @class */ (function () {
        function UrlMapper(templateUrl) {
            this.templateUrl = templateUrl;
        }
        /**
         * Implementação do mapeamento
         *
         * @param content contém o array com o conteúdo ordenado da url
         * @returns A url mapeada
         */
        /**
         * Implementação do mapeamento
         *
         * @param {?} content contém o array com o conteúdo ordenado da url
         * @return {?} A url mapeada
         */
        UrlMapper.prototype.MapTo = /**
         * Implementação do mapeamento
         *
         * @param {?} content contém o array com o conteúdo ordenado da url
         * @return {?} A url mapeada
         */
        function (content) {
            /** @type {?} */
            var modified = this.templateUrl;
            content.forEach((/**
             * @param {?} d
             * @param {?} i
             * @return {?}
             */
            function (d, i) {
                modified = modified.replace("{" + i + "}", d);
            }));
            return modified;
        };
        return UrlMapper;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe abstrata para possuir um mapper de url por padrão
     * @abstract
     */
    var   /**
     * Classe abstrata para possuir um mapper de url por padrão
     * @abstract
     */
    MappedHttp = /** @class */ (function () {
        /**
         * @param urlMapper Um mapper que implementa um mapeamento de parâmetros para url
         */
        function MappedHttp(urlMapper) {
            this.urlMapper = urlMapper;
        }
        return MappedHttp;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Realiza a operação de Get para o enpoint informado, mapeando a entidade antes de enviar
     *
     * @template In, Out
     */
    var   /**
     * Realiza a operação de Get para o enpoint informado, mapeando a entidade antes de enviar
     *
     * @template In, Out
     */
    MappedHttpGetWithQueryString = /** @class */ (function (_super) {
        __extends(MappedHttpGetWithQueryString, _super);
        /**
         * Creates an instance of MappedHttpGet.
         * @param endpoint aceita o formato /api/entity/{0}/other/{1}
         * @param mapper o conversor para o endpoint
         * @param httpClient o cliente http
         */
        function MappedHttpGetWithQueryString(endpoint, mapper, httpClient, urlMapper) {
            if (urlMapper === void 0) { urlMapper = new UrlMapper(endpoint); }
            var _this = _super.call(this, urlMapper) || this;
            _this.mapper = mapper;
            _this.httpClient = httpClient;
            _this._expands = [];
            _this._fields = [];
            return _this;
        }
        Object.defineProperty(MappedHttpGetWithQueryString.prototype, "expands", {
            /** Expansões para a consulta */
            get: /**
             * Expansões para a consulta
             * @return {?}
             */
            function () {
                return this._expands;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MappedHttpGetWithQueryString.prototype, "fields", {
            /** Campos para a consulta */
            get: /**
             * Campos para a consulta
             * @return {?}
             */
            function () {
                return this._fields;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Método responsável por definir as expansões para a consulta
         * @param expands Lista de expansões
         */
        /**
         * Método responsável por definir as expansões para a consulta
         * @param {...?} expands Lista de expansões
         * @return {?}
         */
        MappedHttpGetWithQueryString.prototype.setExpands = /**
         * Método responsável por definir as expansões para a consulta
         * @param {...?} expands Lista de expansões
         * @return {?}
         */
        function () {
            var expands = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                expands[_i] = arguments[_i];
            }
            this._expands = expands;
        };
        /**
         * Método responsável por definir os campos para a consulta
         * @param fields Lista de campos
         */
        /**
         * Método responsável por definir os campos para a consulta
         * @param {...?} fields Lista de campos
         * @return {?}
         */
        MappedHttpGetWithQueryString.prototype.setFields = /**
         * Método responsável por definir os campos para a consulta
         * @param {...?} fields Lista de campos
         * @return {?}
         */
        function () {
            var fields = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                fields[_i] = arguments[_i];
            }
            this._fields = fields;
        };
        /**
         * Implementação da chamada de leitura de um recurso
         *
         * @param params parâmetros da url
         * @returns Deve ser assinado para realizar a leitura do serviço
         */
        /**
         * Implementação da chamada de leitura de um recurso
         *
         * @param {...?} params parâmetros da url
         * @return {?} Deve ser assinado para realizar a leitura do serviço
         */
        MappedHttpGetWithQueryString.prototype.Get = /**
         * Implementação da chamada de leitura de um recurso
         *
         * @param {...?} params parâmetros da url
         * @return {?} Deve ser assinado para realizar a leitura do serviço
         */
        function () {
            var _this = this;
            var params = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                params[_i] = arguments[_i];
            }
            /** @type {?} */
            var template = this.urlMapper.MapTo(params);
            return this.httpClient.get(template, { params: this.getQueryString() }).pipe(operators.map((/**
             * @param {?} data
             * @return {?}
             */
            function (data) { return _this.mapper.MapTo(data); })));
        };
        /**
         * Retorna os parâmetros de consulta(expand e fields) em formato string
         */
        /**
         * Retorna os parâmetros de consulta(expand e fields) em formato string
         * @private
         * @return {?}
         */
        MappedHttpGetWithQueryString.prototype.getQueryString = /**
         * Retorna os parâmetros de consulta(expand e fields) em formato string
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var params = new http.HttpParams();
            if (this.expands && this.expands.length > 0) {
                params = params.set('expand', this.expands.join(','));
            }
            if (this.fields && this.fields.length > 0) {
                params = params.set('fields', this.fields.join(','));
            }
            return params;
        };
        return MappedHttpGetWithQueryString;
    }(MappedHttp));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Realiza a operação de Get para o enpoint informado, mapeando a entidade após recebe-la, com opção de filtros na string
     *
     * @template In, Out
     */
    var   /**
     * Realiza a operação de Get para o enpoint informado, mapeando a entidade após recebe-la, com opção de filtros na string
     *
     * @template In, Out
     */
    MappedHttpGetWithQueryFilter = /** @class */ (function (_super) {
        __extends(MappedHttpGetWithQueryFilter, _super);
        /**
         * Cria uma instância de MappedHttpGetWithQueryFilter.
         * @param endpoint aceita o formato /api/entity/{0}/other/{1}
         * @param mapper o conversor para o endpoint
         * @param httpClient o cliente http
         */
        function MappedHttpGetWithQueryFilter(endpoint, mapper, httpClient, urlMapper) {
            if (urlMapper === void 0) { urlMapper = new UrlMapper(endpoint); }
            var _this = _super.call(this, urlMapper) || this;
            _this.mapper = mapper;
            _this.httpClient = httpClient;
            _this.apiQuery = new ApiQueryString({ page: null, pageSize: null });
            return _this;
        }
        /**
         * Método responsável por definir os filtros por query que devem ser aplicados a consulta
         * @param queryFilter Classe que contém a definição dos filtros
         */
        /**
         * Método responsável por definir os filtros por query que devem ser aplicados a consulta
         * @param {?} queryFilter Classe que contém a definição dos filtros
         * @return {?}
         */
        MappedHttpGetWithQueryFilter.prototype.setQueryFilter = /**
         * Método responsável por definir os filtros por query que devem ser aplicados a consulta
         * @param {?} queryFilter Classe que contém a definição dos filtros
         * @return {?}
         */
        function (queryFilter) {
            this.apiQuery.query = queryFilter;
        };
        /**
         * Implementação da chamada de leitura de um recurso
         *
         * @param params parâmetros da url
         * @returns Deve ser assinado para realizar a leitura do serviço
         */
        /**
         * Implementação da chamada de leitura de um recurso
         *
         * @param {...?} params parâmetros da url
         * @return {?} Deve ser assinado para realizar a leitura do serviço
         */
        MappedHttpGetWithQueryFilter.prototype.Get = /**
         * Implementação da chamada de leitura de um recurso
         *
         * @param {...?} params parâmetros da url
         * @return {?} Deve ser assinado para realizar a leitura do serviço
         */
        function () {
            var _this = this;
            var params = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                params[_i] = arguments[_i];
            }
            /** @type {?} */
            var template = this.urlMapper.MapTo(params);
            return this.httpClient.get(template, { params: this.apiQuery.getQueryString() }).pipe(operators.map((/**
             * @param {?} data
             * @return {?}
             */
            function (data) { return _this.mapper.MapTo(data); })));
        };
        return MappedHttpGetWithQueryFilter;
    }(MappedHttp));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Realiza a operação de Post para o enpoint informado, mapeando a entidade antes de enviar
     * Consumindo o ID a partir do header location
     * @template In, Out
     */
    var   /**
     * Realiza a operação de Post para o enpoint informado, mapeando a entidade antes de enviar
     * Consumindo o ID a partir do header location
     * @template In, Out
     */
    MappedHttpPostLocation = /** @class */ (function (_super) {
        __extends(MappedHttpPostLocation, _super);
        /**
         * Creates an instance of MappedHttpPost.
         * @param endpoint aceita o formato /api/entity/{0}/other/{1}
         * @param mapper o conversor para o endpoint
         * @param httpClient o cliente http
         */
        function MappedHttpPostLocation(endpoint, mapper, httpClient, urlMapper) {
            if (urlMapper === void 0) { urlMapper = new UrlMapper(endpoint); }
            var _this = _super.call(this, urlMapper) || this;
            _this.mapper = mapper;
            _this.httpClient = httpClient;
            return _this;
        }
        /**
         * Implementação da chamada de criação de um recurso
         *
         * @param data dados de entrada para o serviço
         * @param params parâmetros da url
         * @returns Deve ser assinado para realizar a criação do recurso e receber o id
         */
        /**
         * Implementação da chamada de criação de um recurso
         *
         * @param {?=} data dados de entrada para o serviço
         * @param {...?} params parâmetros da url
         * @return {?} Deve ser assinado para realizar a criação do recurso e receber o id
         */
        MappedHttpPostLocation.prototype.Post = /**
         * Implementação da chamada de criação de um recurso
         *
         * @param {?=} data dados de entrada para o serviço
         * @param {...?} params parâmetros da url
         * @return {?} Deve ser assinado para realizar a criação do recurso e receber o id
         */
        function (data) {
            var params = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                params[_i - 1] = arguments[_i];
            }
            /** @type {?} */
            var template = this.urlMapper.MapTo(params);
            return this.httpClient.post(template, this.mapper.MapTo(data), { observe: 'response' })
                .pipe(operators.map((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return res.headers.get('Location').split('/').reverse()[0]; })));
        };
        return MappedHttpPostLocation;
    }(MappedHttp));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Realiza a operação de Put para o enpoint informado, mapeando a entidade antes de enviar
     *
     * @template In, Out, Response
     */
    var   /**
     * Realiza a operação de Put para o enpoint informado, mapeando a entidade antes de enviar
     *
     * @template In, Out, Response
     */
    MappedHttpPut = /** @class */ (function (_super) {
        __extends(MappedHttpPut, _super);
        /**
         * Creates an instance of MappedHttpPut.
         * @param endpoint aceita o formato /api/entity/{0}/other/{1}
         * @param mapper o conversor para o endpoint
         * @param httpClient o cliente http
         */
        function MappedHttpPut(endpoint, mapper, httpClient, urlMapper) {
            if (urlMapper === void 0) { urlMapper = new UrlMapper(endpoint); }
            var _this = _super.call(this, urlMapper) || this;
            _this.mapper = mapper;
            _this.httpClient = httpClient;
            return _this;
        }
        /**
         * Implementação da chamada de atualização de um recurso
         *
         * @param data dados de entrada para o serviço
         * @param params parâmetros da url
         * @returns Deve ser assinado para realizar a atualização do recurso
         */
        /**
         * Implementação da chamada de atualização de um recurso
         *
         * @param {?=} data dados de entrada para o serviço
         * @param {...?} params parâmetros da url
         * @return {?} Deve ser assinado para realizar a atualização do recurso
         */
        MappedHttpPut.prototype.Put = /**
         * Implementação da chamada de atualização de um recurso
         *
         * @param {?=} data dados de entrada para o serviço
         * @param {...?} params parâmetros da url
         * @return {?} Deve ser assinado para realizar a atualização do recurso
         */
        function (data) {
            var params = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                params[_i - 1] = arguments[_i];
            }
            /** @type {?} */
            var template = this.urlMapper.MapTo(params);
            return this.httpClient.put(template, this.mapper.MapTo(data));
        };
        return MappedHttpPut;
    }(MappedHttp));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Realiza a operação de Post para o enpoint informado, mapeando a entidade antes de enviar
     *
     * @template In, Out, Response
     */
    var   /**
     * Realiza a operação de Post para o enpoint informado, mapeando a entidade antes de enviar
     *
     * @template In, Out, Response
     */
    MappedHttpPost = /** @class */ (function (_super) {
        __extends(MappedHttpPost, _super);
        /**
         * Creates an instance of MappedHttpPost.
         * @param endpoint aceita o formato /api/entity/{0}/other/{1}
         * @param mapper o conversor para o endpoint
         * @param httpClient o cliente http
         */
        function MappedHttpPost(endpoint, mapper, httpClient, urlMapper) {
            if (urlMapper === void 0) { urlMapper = new UrlMapper(endpoint); }
            var _this = _super.call(this, urlMapper) || this;
            _this.mapper = mapper;
            _this.httpClient = httpClient;
            return _this;
        }
        /**
         * Implementação da chamada de criação de um recurso
         *
         * @param data dados de entrada para o serviço
         * @param params parâmetros da url
         * @returns Deve ser assinado para realizar a criação do recurso
         */
        /**
         * Implementação da chamada de criação de um recurso
         *
         * @param {?=} data dados de entrada para o serviço
         * @param {...?} params parâmetros da url
         * @return {?} Deve ser assinado para realizar a criação do recurso
         */
        MappedHttpPost.prototype.Post = /**
         * Implementação da chamada de criação de um recurso
         *
         * @param {?=} data dados de entrada para o serviço
         * @param {...?} params parâmetros da url
         * @return {?} Deve ser assinado para realizar a criação do recurso
         */
        function (data) {
            var params = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                params[_i - 1] = arguments[_i];
            }
            /** @type {?} */
            var template = this.urlMapper.MapTo(params);
            return this.httpClient.post(template, this.mapper.MapTo(data));
        };
        return MappedHttpPost;
    }(MappedHttp));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Realiza a operação de Get para o enpoint informado, mapeando a entidade antes de enviar
     *
     * @template In, Out
     */
    var   /**
     * Realiza a operação de Get para o enpoint informado, mapeando a entidade antes de enviar
     *
     * @template In, Out
     */
    MappedHttpGet = /** @class */ (function (_super) {
        __extends(MappedHttpGet, _super);
        /**
         * Creates an instance of MappedHttpGet.
         * @param endpoint aceita o formato /api/entity/{0}/other/{1}
         * @param mapper o conversor para o endpoint
         * @param httpClient o cliente http
         */
        function MappedHttpGet(endpoint, mapper, httpClient, urlMapper) {
            if (urlMapper === void 0) { urlMapper = new UrlMapper(endpoint); }
            var _this = _super.call(this, urlMapper) || this;
            _this.mapper = mapper;
            _this.httpClient = httpClient;
            return _this;
        }
        /**
         * Implementação da chamada de leitura de um recurso
         *
         * @param params parâmetros da url
         * @returns Deve ser assinado para realizar a leitura do serviço
         */
        /**
         * Implementação da chamada de leitura de um recurso
         *
         * @param {...?} params parâmetros da url
         * @return {?} Deve ser assinado para realizar a leitura do serviço
         */
        MappedHttpGet.prototype.Get = /**
         * Implementação da chamada de leitura de um recurso
         *
         * @param {...?} params parâmetros da url
         * @return {?} Deve ser assinado para realizar a leitura do serviço
         */
        function () {
            var _this = this;
            var params = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                params[_i] = arguments[_i];
            }
            /** @type {?} */
            var template = this.urlMapper.MapTo(params);
            return this.httpClient.get(template).pipe(operators.map((/**
             * @param {?} data
             * @return {?}
             */
            function (data) { return _this.mapper.MapTo(data); })));
        };
        return MappedHttpGet;
    }(MappedHttp));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Realiza a operação de Delete para o enpoint informado, mapeando a entidade antes de enviar
     * @template EntityId
     */
    var   /**
     * Realiza a operação de Delete para o enpoint informado, mapeando a entidade antes de enviar
     * @template EntityId
     */
    MappedHttpDelete = /** @class */ (function (_super) {
        __extends(MappedHttpDelete, _super);
        function MappedHttpDelete(endpoint, httpClient, urlMapper) {
            if (urlMapper === void 0) { urlMapper = new UrlMapper(endpoint); }
            var _this = _super.call(this, urlMapper) || this;
            _this.httpClient = httpClient;
            return _this;
        }
        /**
         * Implementação da chamada de deleção de um recurso
         *
         * @returns Deve ser assinado para a deleção ocorrer
         */
        /**
         * Implementação da chamada de deleção de um recurso
         *
         * @param {...?} params
         * @return {?} Deve ser assinado para a deleção ocorrer
         */
        MappedHttpDelete.prototype.Delete = /**
         * Implementação da chamada de deleção de um recurso
         *
         * @param {...?} params
         * @return {?} Deve ser assinado para a deleção ocorrer
         */
        function () {
            var params = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                params[_i] = arguments[_i];
            }
            return this.httpClient.delete(this.urlMapper.MapTo(params));
        };
        return MappedHttpDelete;
    }(MappedHttp));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var TotvsMessageType = {
        success: 0,
        warning: 1,
        error: 2,
        information: 3,
    };
    TotvsMessageType[TotvsMessageType.success] = 'success';
    TotvsMessageType[TotvsMessageType.warning] = 'warning';
    TotvsMessageType[TotvsMessageType.error] = 'error';
    TotvsMessageType[TotvsMessageType.information] = 'information';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Utilitários para formulários
     */
    var   /**
     * Utilitários para formulários
     */
    FormUtils = /** @class */ (function () {
        function FormUtils(form) {
            this.form = form;
        }
        /**
         * Implementação para verificar se o formulário possui algum controle alterado
         */
        /**
         * Implementação para verificar se o formulário possui algum controle alterado
         * @return {?}
         */
        FormUtils.prototype.isFormChanged = /**
         * Implementação para verificar se o formulário possui algum controle alterado
         * @return {?}
         */
        function () {
            /** @type {?} */
            var controls = [];
            if (this.form) {
                controls = controls.concat(this.getControls(this.form));
            }
            while (controls.length > 0) {
                /** @type {?} */
                var control = controls.shift();
                if (control.dirty) {
                    return true;
                }
                else if (control instanceof forms.FormArray) {
                    /** @type {?} */
                    var formArray = (/** @type {?} */ (control));
                    controls = controls.concat(formArray.controls);
                }
                else if (control instanceof forms.FormGroup) {
                    /** @type {?} */
                    var formGroup = (/** @type {?} */ (control));
                    controls = controls.concat(this.getControls(formGroup));
                }
            }
            return false;
        };
        /**
         * @private
         * @param {?} form
         * @return {?}
         */
        FormUtils.prototype.getControls = /**
         * @private
         * @param {?} form
         * @return {?}
         */
        function (form) {
            /** @type {?} */
            var controls = [];
            for (var x in form.controls) {
                if (form.controls[x]) {
                    controls.push(form.controls[x]);
                }
            }
            return controls;
        };
        /**
         * Implementação para marcar o formulário como não mechido pelo usuário
         */
        /**
         * Implementação para marcar o formulário como não mechido pelo usuário
         * @return {?}
         */
        FormUtils.prototype.markFormPristine = /**
         * Implementação para marcar o formulário como não mechido pelo usuário
         * @return {?}
         */
        function () {
            for (var x in this.form.controls) {
                if (this.form.controls[x]) {
                    this.form.controls[x].markAsPristine();
                }
            }
        };
        /**
         * Implementação para verificar a validade do formulário como um todo e marcar os campos inválidos
         */
        /**
         * Implementação para verificar a validade do formulário como um todo e marcar os campos inválidos
         * @return {?}
         */
        FormUtils.prototype.executeFormValidation = /**
         * Implementação para verificar a validade do formulário como um todo e marcar os campos inválidos
         * @return {?}
         */
        function () {
            /** @type {?} */
            var ret = true;
            /** @type {?} */
            var controls = [];
            if (this.form) {
                controls = controls.concat(this.getControls(this.form));
            }
            while (controls.length > 0) {
                /** @type {?} */
                var control = controls.shift();
                if (control.errors &&
                    (!control.errors._isScalar || control.errors.value !== null)) {
                    control.markAsDirty({ onlySelf: true });
                    ret = false;
                }
                else if (control instanceof forms.FormArray) {
                    /** @type {?} */
                    var formArray = (/** @type {?} */ (control));
                    controls = controls.concat(formArray.controls);
                }
                else if (control instanceof forms.FormGroup) {
                    /** @type {?} */
                    var formGroup = (/** @type {?} */ (control));
                    controls = controls.concat(this.getControls(formGroup));
                }
            }
            return ret;
        };
        /**
         * Retorna o form relacionado;
         */
        /**
         * Retorna o form relacionado;
         * @return {?}
         */
        FormUtils.prototype.getForm = /**
         * Retorna o form relacionado;
         * @return {?}
         */
        function () {
            return this.form;
        };
        return FormUtils;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Utilitário de formulário para reduzir boilerplate de interações com um serviço que salve dados
     * \@example
     * export class Component implements OnInit, OnDestroy {
     *   private formUtils: FormUtilsWithService;
     *   private formService: IFormService;
     *   ngOnDestroy() {
     *     this.formUtils.destroy();
     *   }
     *   ngOnInit(): void {
     *     this.formUtils = new FormUtilsWithService(this.form, this.formService);
     *   }
     *   //Salvando dados do formulário
     *   salvar() {
     *     this.formUtils.save().subscribe(() => {});
     *   }
     *   // Exemplo exportando comportamento de formulário alterado e salvo
     * \@Output()
     *   get formularioAlterado(): EventEmitter<void> {
     *     return this.formUtils.formChanged;
     *   }
     * \@Output()
     *   get formularioSalvo(): EventEmitter<boolean> {
     *     return this.formUtils.formSaved;
     *   }
     * }
     * @template T
     */
    var   /**
     * Utilitário de formulário para reduzir boilerplate de interações com um serviço que salve dados
     * \@example
     * export class Component implements OnInit, OnDestroy {
     *   private formUtils: FormUtilsWithService;
     *   private formService: IFormService;
     *   ngOnDestroy() {
     *     this.formUtils.destroy();
     *   }
     *   ngOnInit(): void {
     *     this.formUtils = new FormUtilsWithService(this.form, this.formService);
     *   }
     *   //Salvando dados do formulário
     *   salvar() {
     *     this.formUtils.save().subscribe(() => {});
     *   }
     *   // Exemplo exportando comportamento de formulário alterado e salvo
     * \@Output()
     *   get formularioAlterado(): EventEmitter<void> {
     *     return this.formUtils.formChanged;
     *   }
     * \@Output()
     *   get formularioSalvo(): EventEmitter<boolean> {
     *     return this.formUtils.formSaved;
     *   }
     * }
     * @template T
     */
    FormUtilsWithService = /** @class */ (function () {
        function FormUtilsWithService(form, service, formSaved, formChanged) {
            var _this = this;
            if (formSaved === void 0) { formSaved = new core.EventEmitter(); }
            if (formChanged === void 0) { formChanged = new core.EventEmitter(); }
            this.form = form;
            this.service = service;
            this.formSaved = formSaved;
            this.formChanged = formChanged;
            this.destroy$ = new rxjs.Subject();
            this.formUtils = new FormUtils(form);
            this.form.valueChanges
                .pipe(operators.throttleTime(100), operators.debounceTime(300), operators.takeUntil(this.destroy$))
                .subscribe((/**
             * @return {?}
             */
            function () {
                _this.service.data = _this.form.value;
                _this.formChanged.next(_this.service.data);
            }));
        }
        /**
         * Verifica se o formulário foi alterado e está valido.
         * Solicita ao serviço para salvar
         * Emite o resultado
         */
        /**
         * Verifica se o formulário foi alterado e está valido.
         * Solicita ao serviço para salvar
         * Emite o resultado
         * @return {?}
         */
        FormUtilsWithService.prototype.save = /**
         * Verifica se o formulário foi alterado e está valido.
         * Solicita ao serviço para salvar
         * Emite o resultado
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var validForm = this.executeFormValidation();
            /** @type {?} */
            var changedForm = this.isFormChanged();
            if (changedForm && validForm) {
                return this.service.save().pipe(operators.catchError((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) {
                    _this.formSaved.next(false);
                    return rxjs.throwError(error);
                })), operators.map((/**
                 * @param {?} x
                 * @return {?}
                 */
                function (x) {
                    _this.form.setValue(_this.service.data);
                    _this.formSaved.next(true);
                    _this.formUtils.markFormPristine();
                    return x || _this.service.data;
                })));
            }
            else if (validForm) {
                this.formSaved.next(true);
            }
            else {
                this.formSaved.next(false);
            }
            return rxjs.of(this.service.data);
        };
        /**
         * Remove quaisquer subscrições da classe, evitando memory leak.
         * Deve ser chamado no ngOnDestroy do componente
         */
        /**
         * Remove quaisquer subscrições da classe, evitando memory leak.
         * Deve ser chamado no ngOnDestroy do componente
         * @return {?}
         */
        FormUtilsWithService.prototype.destroy = /**
         * Remove quaisquer subscrições da classe, evitando memory leak.
         * Deve ser chamado no ngOnDestroy do componente
         * @return {?}
         */
        function () {
            this.destroy$.next();
            this.destroy$.complete();
        };
        /**
         * Implementação para verificar se o formulário possui algum controle alterado
         */
        /**
         * Implementação para verificar se o formulário possui algum controle alterado
         * @return {?}
         */
        FormUtilsWithService.prototype.isFormChanged = /**
         * Implementação para verificar se o formulário possui algum controle alterado
         * @return {?}
         */
        function () {
            return this.formUtils.isFormChanged();
        };
        /**
         * Implementação para marcar o formulário como não mechido pelo usuário
         */
        /**
         * Implementação para marcar o formulário como não mechido pelo usuário
         * @return {?}
         */
        FormUtilsWithService.prototype.markFormPristine = /**
         * Implementação para marcar o formulário como não mechido pelo usuário
         * @return {?}
         */
        function () {
            this.formUtils.markFormPristine();
        };
        /**
         * Implementação para verificar a validade do formulário como um todo e marcar os campos inválidos
         */
        /**
         * Implementação para verificar a validade do formulário como um todo e marcar os campos inválidos
         * @return {?}
         */
        FormUtilsWithService.prototype.executeFormValidation = /**
         * Implementação para verificar a validade do formulário como um todo e marcar os campos inválidos
         * @return {?}
         */
        function () {
            return this.formUtils.executeFormValidation();
        };
        /**
         * Retorna o form relacionado;
         */
        /**
         * Retorna o form relacionado;
         * @return {?}
         */
        FormUtilsWithService.prototype.getForm = /**
         * Retorna o form relacionado;
         * @return {?}
         */
        function () {
            return this.form;
        };
        return FormUtilsWithService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var MessageType = {
        ERROR: 1,
        WARNING: 2,
        SUCESS: 4,
        NOTIFICATION: 8,
        EXTERNAL: 16,
        CRITICAL: 32,
    };
    MessageType[MessageType.ERROR] = 'ERROR';
    MessageType[MessageType.WARNING] = 'WARNING';
    MessageType[MessageType.SUCESS] = 'SUCESS';
    MessageType[MessageType.NOTIFICATION] = 'NOTIFICATION';
    MessageType[MessageType.EXTERNAL] = 'EXTERNAL';
    MessageType[MessageType.CRITICAL] = 'CRITICAL';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var ShowMessageType = {
        NotificationSuccess: 0,
        NotificationInformation: 1,
        NotificationError: 2,
        NotificationWarning: 3,
        DialogConfirmation: 4,
        DialogAlert: 5,
    };
    ShowMessageType[ShowMessageType.NotificationSuccess] = 'NotificationSuccess';
    ShowMessageType[ShowMessageType.NotificationInformation] = 'NotificationInformation';
    ShowMessageType[ShowMessageType.NotificationError] = 'NotificationError';
    ShowMessageType[ShowMessageType.NotificationWarning] = 'NotificationWarning';
    ShowMessageType[ShowMessageType.DialogConfirmation] = 'DialogConfirmation';
    ShowMessageType[ShowMessageType.DialogAlert] = 'DialogAlert';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe utilitarios de mensagem
     */
    var   /**
     * Classe utilitarios de mensagem
     */
    MessageUtils = /** @class */ (function () {
        function MessageUtils() {
        }
        /**
         * Retorna o que foi passado formatado.
         */
        /**
         * Retorna o que foi passado formatado.
         * @param {?=} data
         * @return {?}
         */
        MessageUtils.formattable = /**
         * Retorna o que foi passado formatado.
         * @param {?=} data
         * @return {?}
         */
        function (data) {
            return data && data.length !== 0;
        };
        /**
         * Converte de TotvsMessageType para MessageType
         */
        /**
         * Converte de TotvsMessageType para MessageType
         * @param {?} totvsMessageType
         * @return {?}
         */
        MessageUtils.messageTypeFrom = /**
         * Converte de TotvsMessageType para MessageType
         * @param {?} totvsMessageType
         * @return {?}
         */
        function (totvsMessageType) {
            /** @type {?} */
            var type;
            switch (TotvsMessageType[totvsMessageType]) {
                case TotvsMessageType.error:
                    type = MessageType.ERROR;
                    break;
                case TotvsMessageType.information:
                    type = MessageType.NOTIFICATION;
                    break;
                case TotvsMessageType.success:
                    type = MessageType.SUCESS;
                    break;
                case TotvsMessageType.warning:
                    type = MessageType.WARNING;
                    break;
                default:
                    type = MessageType.EXTERNAL;
            }
            return type;
        };
        /**
         * Converte de o type de um totvs message para um showmessagetype, usado no messagedisplayer
         */
        /**
         * Converte de o type de um totvs message para um showmessagetype, usado no messagedisplayer
         * @param {?} message
         * @return {?}
         */
        MessageUtils.showMessageTypeFromTotvsMessage = /**
         * Converte de o type de um totvs message para um showmessagetype, usado no messagedisplayer
         * @param {?} message
         * @return {?}
         */
        function (message) {
            /** @type {?} */
            var messageType;
            switch (message.type) {
                default:
                case 'error':
                    messageType = ShowMessageType.DialogAlert;
                    break;
                case 'information':
                    messageType = ShowMessageType.NotificationInformation;
                    break;
                case 'warning':
                    messageType = ShowMessageType.NotificationInformation;
                    break;
                case 'success':
                    messageType = ShowMessageType.NotificationInformation;
                    break;
            }
            return messageType;
        };
        return MessageUtils;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe de texto da mensagem
     */
    var   /**
     * Classe de texto da mensagem
     */
    TextMessage = /** @class */ (function () {
        /**
         * Construtor da classe
         */
        function TextMessage(msg) {
            this.text = msg.text;
            this.detailText = msg.detailText;
        }
        return TextMessage;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe base de internacionalização
     * @export
     * @abstract
     */
    var   /**
     * Classe base de internacionalização
     * @export
     * @abstract
     */
    I18nBaseService = /** @class */ (function () {
        /**
         * Construtor da classe
         */
        function I18nBaseService(literalLoader) {
            this.literalLoader = literalLoader;
            /**
             * Opções de internacionalização
             */
            this.options = { language: '', url: '' };
        }
        /**
         * Método responsável por setar os atributos definidos da internacionalização context, language, url
         */
        /**
         * Método responsável por setar os atributos definidos da internacionalização context, language, url
         * @param {?} options
         * @return {?}
         */
        I18nBaseService.prototype.updateOptions = /**
         * Método responsável por setar os atributos definidos da internacionalização context, language, url
         * @param {?} options
         * @return {?}
         */
        function (options) {
            var _this = this;
            if (options === undefined) {
                throw new CriticalError('options não definido.', this);
            }
            try {
                Object.assign(this.options, options);
                return this.literalLoader.updateOptions(this.options)
                    .pipe(operators.map((/**
                 * @param {?} res
                 * @return {?}
                 */
                function (res) { return _this.literals = res; })));
            }
            catch (error) {
                throw new CriticalError(error);
            }
        };
        /**
         * Método responsável por setar o formato do valor
         */
        /**
         * Método responsável por setar o formato do valor
         * @param {?} data
         * @param {?} text
         * @return {?}
         */
        I18nBaseService.prototype.format = /**
         * Método responsável por setar o formato do valor
         * @param {?} data
         * @param {?} text
         * @return {?}
         */
        function (data, text) {
            if (MessageUtils.formattable(data)) {
                data.forEach((/**
                 * @param {?} d
                 * @param {?} i
                 * @return {?}
                 */
                function (d, i) {
                    text = text.replace("{" + i + "}", d);
                }));
                return text;
            }
            else {
                return text;
            }
        };
        /**
         * Método responsável por buscar e setar a literal do detalhe da mensagem
         */
        /**
         * Método responsável por buscar e setar a literal do detalhe da mensagem
         * @param {?} baseMsg
         * @return {?}
         */
        I18nBaseService.prototype.text = /**
         * Método responsável por buscar e setar a literal do detalhe da mensagem
         * @param {?} baseMsg
         * @return {?}
         */
        function (baseMsg) {
            /** @type {?} */
            var msg;
            try {
                /** @type {?} */
                var detail = '';
                if (baseMsg.detail) {
                    detail = this.format(baseMsg.detailData, this.literals[baseMsg.detail]);
                }
                msg = new TextMessage({
                    text: this.format(baseMsg.literalData, this.literals[baseMsg.literal]),
                    detailText: detail
                });
            }
            catch (error) {
                // tslint:disable-next-line:max-line-length
                throw new CriticalError("Literais n\u00E3o encontradas '" + baseMsg.literal + "'/'" + baseMsg.detail + "'");
            }
            return msg;
        };
        /**
         * Método responsável por retornar se tem literal
         */
        /**
         * Método responsável por retornar se tem literal
         * @param {?} literal
         * @return {?}
         */
        I18nBaseService.prototype.hasLiteral = /**
         * Método responsável por retornar se tem literal
         * @param {?} literal
         * @return {?}
         */
        function (literal) {
            try {
                return this.literals[literal] !== undefined;
            }
            catch (error) {
                console.log(error);
                return false;
            }
        };
        /**
         * Método responsável por retornar as opções de linguagem
         */
        /**
         * Método responsável por retornar as opções de linguagem
         * @return {?}
         */
        I18nBaseService.prototype.getLanguage = /**
         * Método responsável por retornar as opções de linguagem
         * @return {?}
         */
        function () {
            return this.options.language;
        };
        /**
         * Método responsável por retornar os idiomas suportados pela aplicação
         */
        /**
         * Método responsável por retornar os idiomas suportados pela aplicação
         * @return {?}
         */
        I18nBaseService.prototype.getSupportedLanguages = /**
         * Método responsável por retornar os idiomas suportados pela aplicação
         * @return {?}
         */
        function () {
            return this.options.supportedLanguages;
        };
        return I18nBaseService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe abstrata padrão de loading
     * @abstract
     */
    var   /**
     * Classe abstrata padrão de loading
     * @abstract
     */
    LoadingDefault = /** @class */ (function () {
        function LoadingDefault() {
        }
        /**
         * Execução do loading
         */
        /**
         * Execução do loading
         * @template Z
         * @param {?} callback
         * @param {...?} args
         * @return {?}
         */
        LoadingDefault.prototype.executeLoading = /**
         * Execução do loading
         * @template Z
         * @param {?} callback
         * @param {...?} args
         * @return {?}
         */
        function (callback) {
            var _this = this;
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            this.showLoading();
            /** @type {?} */
            var fn = (/** @type {?} */ (callback.apply(void 0, __spread(args))));
            if (fn instanceof Promise) {
                fn
                    .then((/**
                 * @param {?} data
                 * @return {?}
                 */
                function (data) { _this.hideLoading(); return data; }))
                    .catch((/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) { _this.hideLoading(); return error; }));
            }
            else if (fn instanceof rxjs.Observable) {
                /** @type {?} */
                var obs = (/** @type {?} */ (fn));
                obs.pipe(operators.map((/**
                 * @param {?} data
                 * @return {?}
                 */
                function (data) { _this.hideLoading(); return data; })))
                    .subscribe();
            }
            else {
                setTimeout((/**
                 * @return {?}
                 */
                function () { return _this.hideLoading(); }), 50);
            }
            return fn;
        };
        return LoadingDefault;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe abstrata de apresentação de mensagem
     * @abstract
     */
    var   /**
     * Classe abstrata de apresentação de mensagem
     * @abstract
     */
    AbstractShowMessage = /** @class */ (function () {
        function AbstractShowMessage() {
        }
        return AbstractShowMessage;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var ShowMessageLinkActionType = {
        No: 0,
        LinkNewTab: 1,
        Method: 2,
    };
    ShowMessageLinkActionType[ShowMessageLinkActionType.No] = 'No';
    ShowMessageLinkActionType[ShowMessageLinkActionType.LinkNewTab] = 'LinkNewTab';
    ShowMessageLinkActionType[ShowMessageLinkActionType.Method] = 'Method';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe com as opções de apresentação de mensagem
     */
    var   /**
     * Classe com as opções de apresentação de mensagem
     */
    ShowMessageOptions = /** @class */ (function () {
        function ShowMessageOptions() {
        }
        return ShowMessageOptions;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe base de mensagens
     */
    var   /**
     * Classe base de mensagens
     */
    BaseMessage = /** @class */ (function () {
        /**
         * Método construtor da classe
         */
        function BaseMessage(msg) {
            /**
             * Tipo da mensagem que carrega
             */
            this._messageType = ShowMessageType.NotificationSuccess;
            this.literal = msg.literal;
            if (msg.detail) {
                this.detail = msg.detail;
            }
        }
        Object.defineProperty(BaseMessage.prototype, "messageType", {
            /** Tipo da mensagem que carrega */
            get: /**
             * Tipo da mensagem que carrega
             * @return {?}
             */
            function () {
                return this._messageType;
            },
            enumerable: true,
            configurable: true
        });
        /** Builder para setar o tipo de mensagem */
        /**
         * Builder para setar o tipo de mensagem
         * @param {?} messageType
         * @return {?}
         */
        BaseMessage.prototype.withMessageType = /**
         * Builder para setar o tipo de mensagem
         * @param {?} messageType
         * @return {?}
         */
        function (messageType) {
            this._messageType = messageType;
            return this;
        };
        Object.defineProperty(BaseMessage.prototype, "literal", {
            /**
             * Método que busca a literal
             */
            get: /**
             * Método que busca a literal
             * @return {?}
             */
            function () {
                return this._literal;
            },
            /**
             * Método que seta a literal
             */
            set: /**
             * Método que seta a literal
             * @param {?} literal
             * @return {?}
             */
            function (literal) {
                try {
                    this.isLiteralValid(literal);
                }
                catch (error) {
                    throw (error);
                }
                this._literal = literal;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BaseMessage.prototype, "detail", {
            /**
             * Método que busca o detalhe da literal
             */
            get: /**
             * Método que busca o detalhe da literal
             * @return {?}
             */
            function () {
                return this._detail;
            },
            /**
             * Método que seta o detalhe da literal
             */
            set: /**
             * Método que seta o detalhe da literal
             * @param {?} detail
             * @return {?}
             */
            function (detail) {
                try {
                    this.isLiteralValid(detail);
                }
                catch (error) {
                    throw (error);
                }
                this._detail = detail;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Facilita a adição de dados para formatação da literal
         */
        /**
         * Facilita a adição de dados para formatação da literal
         * @template THIS
         * @this {THIS}
         * @param {?} data
         * @return {THIS}
         */
        BaseMessage.prototype.withLiteralData = /**
         * Facilita a adição de dados para formatação da literal
         * @template THIS
         * @this {THIS}
         * @param {?} data
         * @return {THIS}
         */
        function (data) {
            (/** @type {?} */ (this))._literalData = data;
            return (/** @type {?} */ (this));
        };
        Object.defineProperty(BaseMessage.prototype, "literalData", {
            /**
             * Método que busca a literal
             */
            get: /**
             * Método que busca a literal
             * @return {?}
             */
            function () {
                return this._literalData;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Facilita a adição de dados para formatação do detalhe da literal
         */
        /**
         * Facilita a adição de dados para formatação do detalhe da literal
         * @template THIS
         * @this {THIS}
         * @param {?} data
         * @return {THIS}
         */
        BaseMessage.prototype.withDetailData = /**
         * Facilita a adição de dados para formatação do detalhe da literal
         * @template THIS
         * @this {THIS}
         * @param {?} data
         * @return {THIS}
         */
        function (data) {
            (/** @type {?} */ (this))._detailData = data;
            return (/** @type {?} */ (this));
        };
        Object.defineProperty(BaseMessage.prototype, "detailData", {
            /**
             * Método que busca o detalhe da literal
             */
            get: /**
             * Método que busca o detalhe da literal
             * @return {?}
             */
            function () {
                return this._detailData;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BaseMessage.prototype, "literalFormattable", {
            /**
             * Método que busca a literal formatada
             */
            get: /**
             * Método que busca a literal formatada
             * @return {?}
             */
            function () {
                return MessageUtils.formattable(this._literalData);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BaseMessage.prototype, "detailFormattable", {
            /**
             * Método que busca o detalhe da literal formatado
             */
            get: /**
             * Método que busca o detalhe da literal formatado
             * @return {?}
             */
            function () {
                return MessageUtils.formattable(this._detailData);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Método de internacionalização de mensagem
         */
        /**
         * Método de internacionalização de mensagem
         * @param {?} i18n
         * @return {?}
         */
        BaseMessage.prototype.messageI18n = /**
         * Método de internacionalização de mensagem
         * @param {?} i18n
         * @return {?}
         */
        function (i18n) {
            return i18n.text(this);
        };
        /**
         * Método que verifica se literal é válida
         */
        /**
         * Método que verifica se literal é válida
         * @protected
         * @param {?} literal
         * @return {?}
         */
        BaseMessage.prototype.isLiteralValid = /**
         * Método que verifica se literal é válida
         * @protected
         * @param {?} literal
         * @return {?}
         */
        function (literal) {
            if (literal === undefined) {
                throw new CriticalError('Literal não pode ser undefined.');
            }
            else if (literal.length === 0) {
                throw new CriticalError('Literal não pode ser uma string vazia.');
            }
            else if (literal.search(' ') !== -1) {
                throw new CriticalError('Literal não pode conter espaços.');
            }
            try {
                Object.create({ literal: literal });
            }
            catch (erro) {
                throw new CriticalError(erro);
            }
        };
        return BaseMessage;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe abstrata de conversor e exibição de Hora
     * @abstract
     */
    var   /**
     * Classe abstrata de conversor e exibição de Hora
     * @abstract
     */
    TimeViewConverter = /** @class */ (function () {
        /**
         * Construtor da classe
         */
        function TimeViewConverter(transformer) {
            this.transformer = transformer;
        }
        return TimeViewConverter;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe/pipe para aplicação de transformação em um objeto data
     */
    var TimePipe = /** @class */ (function () {
        /**
         * Método construtor da classe
         */
        function TimePipe(timeViewConverter, i18n) {
            this.timeViewConverter = timeViewConverter;
            this.i18n = i18n;
        }
        /**
         * Método padrão para aplicação do Pipe
         * @param value recebe o objeto que contém as informações
         * @param format  recebe as informações de formato
         */
        /**
         * Método padrão para aplicação do Pipe
         * @param {?} value recebe o objeto que contém as informações
         * @param {?} format  recebe as informações de formato
         * @return {?}
         */
        TimePipe.prototype.transform = /**
         * Método padrão para aplicação do Pipe
         * @param {?} value recebe o objeto que contém as informações
         * @param {?} format  recebe as informações de formato
         * @return {?}
         */
        function (value, format) {
            this.timeViewConverter.language = this.i18n.getLanguage();
            return this.timeViewConverter.toView(value, format);
        };
        TimePipe.decorators = [
            { type: core.Pipe, args: [{
                        name: 'time',
                        pure: false
                    },] }
        ];
        /** @nocollapse */
        TimePipe.ctorParameters = function () { return [
            { type: TimeViewConverter },
            { type: I18nBaseService }
        ]; };
        return TimePipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe padrão do serviço de conversão e exibição de Hora
     */
    var DefaultTimeViewConverterService = /** @class */ (function (_super) {
        __extends(DefaultTimeViewConverterService, _super);
        /**
         * Contrutor da classe
         */
        function DefaultTimeViewConverterService(transformer) {
            var _this = _super.call(this, transformer) || this;
            _this.transformer = transformer;
            return _this;
        }
        /**
         * Método responsável pela visualização da hora formatada
         */
        /**
         * Método responsável pela visualização da hora formatada
         * @param {?} value
         * @param {?=} format
         * @return {?}
         */
        DefaultTimeViewConverterService.prototype.toView = /**
         * Método responsável pela visualização da hora formatada
         * @param {?} value
         * @param {?=} format
         * @return {?}
         */
        function (value, format) {
            /** @type {?} */
            var timeFormat = format ? format : ApiDateTimeConstants.TIME_FORMAT;
            return this.transformer.transform(value, timeFormat);
        };
        DefaultTimeViewConverterService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        DefaultTimeViewConverterService.ctorParameters = function () { return [
            { type: common.DatePipe }
        ]; };
        return DefaultTimeViewConverterService;
    }(TimeViewConverter));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe abstrata de conversor e exibição de data
     * @abstract
     */
    var   /**
     * Classe abstrata de conversor e exibição de data
     * @abstract
     */
    DateViewConverter = /** @class */ (function () {
        /**
         * Método construtor da classe
         */
        function DateViewConverter(transformer) {
            this.transformer = transformer;
        }
        return DateViewConverter;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe padrão do serviço de conversão e exibição de data
     */
    var DefaultDateViewConverterService = /** @class */ (function (_super) {
        __extends(DefaultDateViewConverterService, _super);
        /**
         * Método construtor da classe
         */
        function DefaultDateViewConverterService(transformer) {
            var _this = _super.call(this, transformer) || this;
            _this.transformer = transformer;
            return _this;
        }
        /**
         * Método responsável pela visualização do valor formatado
         */
        /**
         * Método responsável pela visualização do valor formatado
         * @param {?} value
         * @param {?=} format
         * @return {?}
         */
        DefaultDateViewConverterService.prototype.toView = /**
         * Método responsável pela visualização do valor formatado
         * @param {?} value
         * @param {?=} format
         * @return {?}
         */
        function (value, format) {
            /** @type {?} */
            var formatDate;
            if (format) {
                formatDate = format;
            }
            else {
                if (this.language && !this.language.includes('pt')) {
                    formatDate = ApiDateTimeConstants.DATE_FORMAT_DISPLAY_EN;
                }
                else {
                    formatDate = ApiDateTimeConstants.DATE_FORMAT_DISPLAY_PT;
                }
            }
            return this.transformer.transform(value, formatDate);
        };
        DefaultDateViewConverterService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        DefaultDateViewConverterService.ctorParameters = function () { return [
            { type: common.DatePipe }
        ]; };
        return DefaultDateViewConverterService;
    }(DateViewConverter));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe/pipe para aplicação de transformação em um objeto data
     */
    var DateTimePipe = /** @class */ (function () {
        /**
         * Método construtor da clase
         */
        function DateTimePipe(dateViewConverter, i18n) {
            this.dateViewConverter = dateViewConverter;
            this.i18n = i18n;
        }
        /**
         * Método padrão para aplicação do Pipe
         * @param value recebe o objeto que contém as informações
         * @param format  recebe as informações de formato
         */
        /**
         * Método padrão para aplicação do Pipe
         * @param {?} value recebe o objeto que contém as informações
         * @param {?} format  recebe as informações de formato
         * @return {?}
         */
        DateTimePipe.prototype.transform = /**
         * Método padrão para aplicação do Pipe
         * @param {?} value recebe o objeto que contém as informações
         * @param {?} format  recebe as informações de formato
         * @return {?}
         */
        function (value, format) {
            this.dateViewConverter.language = this.i18n.getLanguage();
            return this.dateViewConverter.toView(value, format);
        };
        DateTimePipe.decorators = [
            { type: core.Pipe, args: [{
                        name: 'dateTime',
                        pure: false
                    },] }
        ];
        /** @nocollapse */
        DateTimePipe.ctorParameters = function () { return [
            { type: DateViewConverter },
            { type: I18nBaseService }
        ]; };
        return DateTimePipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var AuthHandlerType = {
        /** Tipos possíveis de autenticação */
        oauth2: 0,
    };
    AuthHandlerType[AuthHandlerType.oauth2] = 'oauth2';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UrlUtils = /** @class */ (function () {
        function UrlUtils() {
        }
        /**
         * Substitui o placeholder {tenant} pelo shortname do tenanat presente na Url atual
         * @param url Url contendo o placeholder {tenant} que será substituído pelo tenant informado na Url atual
         */
        /**
         * Substitui o placeholder {tenant} pelo shortname do tenanat presente na Url atual
         * @return {?}
         */
        UrlUtils.GetTenantFromUrl = /**
         * Substitui o placeholder {tenant} pelo shortname do tenanat presente na Url atual
         * @return {?}
         */
        function () {
            return window.location.origin.split('//')[1].split('.')[0];
        };
        return UrlUtils;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var jwtDecode = jwtDecode_;
    /**
     * Token de configuração das informações
     * @type {?}
     */
    var AUTH_SETTINGS = new core.InjectionToken('AUTH_SETTINGS: IAuthSettings Configurações de gerenciamento de sessão e token');
    /**
     * Configuração do tipo de autenticação
     * @type {?}
     */
    var AUTH_TYPE = new core.InjectionToken('AUTH_TYPE: IAuthHandlerType Token com o tipo de autenticação usada');
    /**
     * Classe abstrata do serviço de autorização
     * @abstract
     */
    var   /**
     * Classe abstrata do serviço de autorização
     * @abstract
     */
    AuthBaseService = /** @class */ (function () {
        /**
         * Método construtor da classe
         * @param authSettings Token de injeção com as configurações de autenticação
         * @param authType Token de injeção com o tipo de autenticação
         */
        function AuthBaseService(authSettings) {
            /**
             * @ignore
             */
            this._isInitialized = false;
            /**
             * Evento emitido nas situações em que o usuário está logado
             */
            this.userLoadedEvent = new core.EventEmitter();
            /**
             * Evento emitido nas situações em que o token de acesso expirou
             */
            this.accessTokenExpired = new core.EventEmitter();
            /**
             * Evento emitido de acordo com o número de segundos definido para disparar
             * o aviso antes da expiração do token. (Número de segundos definido
             * no atributo accessTokenExpiringNotificationTime do token de injeção AUTH_SETTINGS)
             */
            this.accessTokenExpiring = new core.EventEmitter();
            this.authSettingsTemplate = authSettings;
            this.authSettingsUsed = authSettings;
            if (!this.authSettingsUsed.initLazy) {
                this.setShortNameTenant(UrlUtils.GetTenantFromUrl());
            }
        }
        Object.defineProperty(AuthBaseService.prototype, "shortNameTenant", {
            /**
             * Nome abrevido do tenant corrente identificado no serviço de autorização
             */
            get: /**
             * Nome abrevido do tenant corrente identificado no serviço de autorização
             * @return {?}
             */
            function () {
                return this._shortNameTenant;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuthBaseService.prototype, "isInitialized", {
            /**
             * Propriedade que indica que o serviço foi inicializado devido a possibilidade de
             * carregar o serviço de forma lazy
             */
            get: /**
             * Propriedade que indica que o serviço foi inicializado devido a possibilidade de
             * carregar o serviço de forma lazy
             * @return {?}
             */
            function () {
                return this._isInitialized;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Método responsável por inicializar o UserManager
         * @param authSettings Configurações de gerenciamento de sessão e token
         */
        /**
         * Método responsável por inicializar o UserManager
         * @private
         * @param {?} authSettings Configurações de gerenciamento de sessão e token
         * @return {?}
         */
        AuthBaseService.prototype.init = /**
         * Método responsável por inicializar o UserManager
         * @private
         * @param {?} authSettings Configurações de gerenciamento de sessão e token
         * @return {?}
         */
        function (authSettings) {
            return __awaiter(this, void 0, void 0, function () {
                var user;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            this.manager = new oidcClient.UserManager(authSettings);
                            // Carrega o usuário atualmente autenticado
                            return [4 /*yield*/, this.getUser()];
                        case 1:
                            user = _a.sent();
                            this._currentUser = user;
                            if (this._currentUser) {
                                this.userLoadedEvent.emit(this._currentUser);
                            }
                            this.addEventAccessTokenExpired();
                            this.addEventAccessTokenExpiring();
                            this._isInitialized = true;
                            return [2 /*return*/, user];
                    }
                });
            });
        };
        /**
         * Método responsável por identificar o tenant para o serviço de autorização.
         * Ao setar, o serviço é inicializado novamente
         * @param shortNameTenant Nome abreviado do tenant
         * @return Usuário atualmente autenticado
         */
        /**
         * Método responsável por identificar o tenant para o serviço de autorização.
         * Ao setar, o serviço é inicializado novamente
         * @param {?} shortNameTenant Nome abreviado do tenant
         * @return {?} Usuário atualmente autenticado
         */
        AuthBaseService.prototype.setShortNameTenant = /**
         * Método responsável por identificar o tenant para o serviço de autorização.
         * Ao setar, o serviço é inicializado novamente
         * @param {?} shortNameTenant Nome abreviado do tenant
         * @return {?} Usuário atualmente autenticado
         */
        function (shortNameTenant) {
            return __awaiter(this, void 0, void 0, function () {
                var authority, authSettings;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            this._shortNameTenant = shortNameTenant;
                            authority = this.authSettingsTemplate.authority.replace("{tenant}", this.shortNameTenant);
                            authSettings = Object.assign({}, this.authSettingsUsed, { acr_values: "tenant:" + this.shortNameTenant }, { authority: authority });
                            this.authSettingsUsed = authSettings;
                            return [4 /*yield*/, this.init(this.authSettingsUsed)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        /**
         * Método responsável por alterar as configurações de autenticação
         * @param authSettings Configurações de autenticação
         */
        /**
         * Método responsável por alterar as configurações de autenticação
         * @param {?} authSettings Configurações de autenticação
         * @return {?}
         */
        AuthBaseService.prototype.changeAuthSettings = /**
         * Método responsável por alterar as configurações de autenticação
         * @param {?} authSettings Configurações de autenticação
         * @return {?}
         */
        function (authSettings) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this.authSettingsTemplate = authSettings;
                    this.authSettingsUsed = authSettings;
                    return [2 /*return*/];
                });
            });
        };
        /**
         * Adiciona o evento de aviso que o token irá expirar, de acordo com o número de segundos
         * definido no atributo accessTokenExpiringNotificationTime do token de injeção AUTH_SETTINGS
         */
        /**
         * Adiciona o evento de aviso que o token irá expirar, de acordo com o número de segundos
         * definido no atributo accessTokenExpiringNotificationTime do token de injeção AUTH_SETTINGS
         * @private
         * @return {?}
         */
        AuthBaseService.prototype.addEventAccessTokenExpiring = /**
         * Adiciona o evento de aviso que o token irá expirar, de acordo com o número de segundos
         * definido no atributo accessTokenExpiringNotificationTime do token de injeção AUTH_SETTINGS
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            this.manager.events.addAccessTokenExpiring((/**
             * @param {?} e
             * @return {?}
             */
            function (e) {
                _this.accessTokenExpiring.emit(true);
            }));
        };
        /**
         * Adiciona o evento de token expirado, após o token expirar o mesmo é disparado
         */
        /**
         * Adiciona o evento de token expirado, após o token expirar o mesmo é disparado
         * @private
         * @return {?}
         */
        AuthBaseService.prototype.addEventAccessTokenExpired = /**
         * Adiciona o evento de token expirado, após o token expirar o mesmo é disparado
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            this.manager.events.addAccessTokenExpired((/**
             * @param {?} e
             * @return {?}
             */
            function (e) {
                _this.accessTokenExpired.emit(true);
            }));
        };
        /**
         * Método responsável por retornar um observable indicando se o usuário
         * está logado
         */
        /**
         * Método responsável por retornar um observable indicando se o usuário
         * está logado
         * @return {?}
         */
        AuthBaseService.prototype.isLoggedInObs = /**
         * Método responsável por retornar um observable indicando se o usuário
         * está logado
         * @return {?}
         */
        function () {
            return rxjs.from(this.manager.getUser()).pipe(operators.map((/**
             * @param {?} user
             * @return {?}
             */
            function (user) {
                if (user && !user.expired) {
                    return true;
                }
                else {
                    return false;
                }
            })));
        };
        /**
         * Método responsável por retornar o tipo do token
         */
        /**
         * Método responsável por retornar o tipo do token
         * @return {?}
         */
        AuthBaseService.prototype.getUserTokenType = /**
         * Método responsável por retornar o tipo do token
         * @return {?}
         */
        function () {
            return this._currentUser.token_type;
        };
        /**
         * Método responsável por retornar o token de acesso
         */
        /**
         * Método responsável por retornar o token de acesso
         * @return {?}
         */
        AuthBaseService.prototype.getUserAccessToken = /**
         * Método responsável por retornar o token de acesso
         * @return {?}
         */
        function () {
            return this._currentUser.access_token;
        };
        /**
         * Método responsável por retornar o usuário autenticado
         */
        /**
         * Método responsável por retornar o usuário autenticado
         * @return {?}
         */
        AuthBaseService.prototype.getUser = /**
         * Método responsável por retornar o usuário autenticado
         * @return {?}
         */
        function () {
            var _this = this;
            return this.manager.getUser().then((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                if (x && x.access_token) {
                    try {
                        /** @type {?} */
                        var decodedJsonToken = jwtDecode(x.access_token);
                        x.profile.roles = decodedJsonToken.role;
                        if (!Array.isArray(x.profile.roles)) {
                            x.profile.roles = [x.profile.roles];
                        }
                        Object.assign(x.profile, _this.extractDataFrom(decodedJsonToken));
                    }
                    catch (error) {
                        console.error(error);
                    }
                }
                return x;
            }));
        };
        /**
         * Utiliza o parâmetro extractFromTokenToUserProfile para extrair apenas os dados especificados
         * @param decodedJsonToken O objeto json decodificado
         */
        /**
         * Utiliza o parâmetro extractFromTokenToUserProfile para extrair apenas os dados especificados
         * @param {?} decodedJsonToken O objeto json decodificado
         * @return {?}
         */
        AuthBaseService.prototype.extractDataFrom = /**
         * Utiliza o parâmetro extractFromTokenToUserProfile para extrair apenas os dados especificados
         * @param {?} decodedJsonToken O objeto json decodificado
         * @return {?}
         */
        function (decodedJsonToken) {
            /** @type {?} */
            var obj = {};
            if (this.authSettingsUsed.extractFromTokenToUserProfile) {
                this.authSettingsUsed.extractFromTokenToUserProfile.forEach((/**
                 * @param {?} mapping
                 * @return {?}
                 */
                function (mapping) {
                    if (!decodedJsonToken[mapping.from]) {
                        console.error("Atributo " + mapping.from + " n\u00E3o encontrado no token'" + JSON.stringify(decodedJsonToken, undefined, 2) + "'");
                        return;
                    }
                    Object.assign(obj, mapping.to(decodedJsonToken[mapping.from]));
                }));
            }
            return obj;
        };
        /**
         * Método responsável por retornar o header de autorização
         */
        /**
         * Método responsável por retornar o header de autorização
         * @return {?}
         */
        AuthBaseService.prototype.getAuthorizationHeaderValue = /**
         * Método responsável por retornar o header de autorização
         * @return {?}
         */
        function () {
            return this._currentUser
                ? this._currentUser.token_type + " " + this._currentUser.access_token
                : '';
        };
        /**
         * Método responsável por redirecionar a janela atual para o endpoint
         * de autorização
         */
        /**
         * Método responsável por redirecionar a janela atual para o endpoint
         * de autorização
         * @return {?}
         */
        AuthBaseService.prototype.signinRedirect = /**
         * Método responsável por redirecionar a janela atual para o endpoint
         * de autorização
         * @return {?}
         */
        function () {
            this.manager.signinRedirect();
        };
        /**
         * Método responsável por redirecionar a janela atual para
         * o endpoint de término da sessão
         */
        /**
         * Método responsável por redirecionar a janela atual para
         * o endpoint de término da sessão
         * @return {?}
         */
        AuthBaseService.prototype.signoutRedirect = /**
         * Método responsável por redirecionar a janela atual para
         * o endpoint de término da sessão
         * @return {?}
         */
        function () {
            this.manager.signoutRedirect();
        };
        /**
         * Método responsável por processar a resposta do endpoint de autorização,
         * retornando o usuário autenticado
         */
        /**
         * Método responsável por processar a resposta do endpoint de autorização,
         * retornando o usuário autenticado
         * @return {?}
         */
        AuthBaseService.prototype.signinRedirectCallback = /**
         * Método responsável por processar a resposta do endpoint de autorização,
         * retornando o usuário autenticado
         * @return {?}
         */
        function () {
            if (window.location.hash) {
                window.location.hash = decodeURIComponent(window.location.hash);
                return this.manager.signinRedirectCallback();
            }
            else {
                return this.getUser();
            }
        };
        /**
         * Método disparado ao completar autenticação, emitindo evento caso
         * o usuário esteja realmente autenticado, ou redirecionando para o endpoint de autorização
         * caso não esteja autenticado
         */
        /**
         * Método disparado ao completar autenticação, emitindo evento caso
         * o usuário esteja realmente autenticado, ou redirecionando para o endpoint de autorização
         * caso não esteja autenticado
         * @return {?}
         */
        AuthBaseService.prototype.completeAuthentication = /**
         * Método disparado ao completar autenticação, emitindo evento caso
         * o usuário esteja realmente autenticado, ou redirecionando para o endpoint de autorização
         * caso não esteja autenticado
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4 /*yield*/, this.signinRedirectCallback()];
                        case 1:
                            _b.sent();
                            _a = this;
                            return [4 /*yield*/, this.getUser()];
                        case 2:
                            _a._currentUser = _b.sent();
                            if (this._currentUser) {
                                this.userLoadedEvent.emit(this._currentUser);
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Método responsável por autorizar o direcionamento para uma determinada rota,
         * caso o usuário esteja expirado executa o processo de signout, caso esteja inválido
         * executa a função para o processo de login
         */
        /**
         * Método responsável por autorizar o direcionamento para uma determinada rota,
         * caso o usuário esteja expirado executa o processo de signout, caso esteja inválido
         * executa a função para o processo de login
         * @return {?}
         */
        AuthBaseService.prototype.authorize = /**
         * Método responsável por autorizar o direcionamento para uma determinada rota,
         * caso o usuário esteja expirado executa o processo de signout, caso esteja inválido
         * executa a função para o processo de login
         * @return {?}
         */
        function () {
            var _this = this;
            return this.getUser().then((/**
             * @param {?} user
             * @return {?}
             */
            function (user) {
                if (user) {
                    if (user.expired) {
                        _this.logoutFlow();
                        return false;
                    }
                    return true;
                }
                _this.loginFlow();
                return false;
            }));
        };
        return AuthBaseService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AuthInterceptorHandlerService = /** @class */ (function () {
        /**
         * Creates an instance of AuthInterceptorHandlerService.
         */
        function AuthInterceptorHandlerService(auth, authType) {
            this.auth = auth;
            this.authType = authType;
        }
        /**
         * Implementação da interface de interceptação HTTP
         * que apenas adiciona ao cabeçalho da requisição o token.
         */
        /**
         * Implementação da interface de interceptação HTTP
         * que apenas adiciona ao cabeçalho da requisição o token.
         * @param {?} request
         * @param {?} next
         * @return {?}
         */
        AuthInterceptorHandlerService.prototype.intercept = /**
         * Implementação da interface de interceptação HTTP
         * que apenas adiciona ao cabeçalho da requisição o token.
         * @param {?} request
         * @param {?} next
         * @return {?}
         */
        function (request, next) {
            var _this = this;
            if (this.authType.type === AuthHandlerType.oauth2 && this.auth.isInitialized) {
                return rxjs.from(this.auth.getUser())
                    .pipe(operators.mergeMap((/**
                 * @param {?} user
                 * @return {?}
                 */
                function (user) {
                    /** @type {?} */
                    var headers = request.headers.set('Authorization', user ? user.token_type + " " + user.access_token : '');
                    /** @type {?} */
                    var reqClone = request.clone({
                        headers: headers,
                        url: request.url.replace('{tenant}', _this.auth.shortNameTenant || '')
                    });
                    return next.handle(reqClone);
                })));
            }
            else {
                return next.handle(request);
            }
        };
        AuthInterceptorHandlerService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        AuthInterceptorHandlerService.ctorParameters = function () { return [
            { type: AuthBaseService },
            { type: undefined, decorators: [{ type: core.Inject, args: [AUTH_TYPE,] }] }
        ]; };
        return AuthInterceptorHandlerService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Constante usado nas requisições para que os erros não sejam exibidos pelo interceptor
     * @type {?}
     */
    var NO_ERROR_HEADER_PARAM = 'X-Totvs-No-Error';
    /**
     * Classe base de interceptadores http.
     * Pode ser extendida ou apenas implementar IHttpInterceptor e usar de seus métodos estáticos.
     * @abstract
     */
    var   /**
     * Classe base de interceptadores http.
     * Pode ser extendida ou apenas implementar IHttpInterceptor e usar de seus métodos estáticos.
     * @abstract
     */
    HttpInterceptorBaseService = /** @class */ (function () {
        function HttpInterceptorBaseService() {
        }
        /**
         * Interceptador de respostas http padrão
         * @param request HttpRequest<any>
         * @param next HttpHandler
         * @param instance Instancia que implementa IHttpInterceptor
         */
        /**
         * Interceptador de respostas http padrão
         * @param {?} request HttpRequest<any>
         * @param {?} next HttpHandler
         * @param {?} instance Instancia que implementa IHttpInterceptor
         * @return {?}
         */
        HttpInterceptorBaseService.defaultInterceptor = /**
         * Interceptador de respostas http padrão
         * @param {?} request HttpRequest<any>
         * @param {?} next HttpHandler
         * @param {?} instance Instancia que implementa IHttpInterceptor
         * @return {?}
         */
        function (request, 
        /** Próxima manipulação http */
        next, 
        /** Instância do interceptador */
        instance) {
            /** @type {?} */
            var cloneRequest = request.clone();
            request = request.headers.has(NO_ERROR_HEADER_PARAM)
                ? HttpInterceptorBaseService.cloneRequestWithoutErrorsHeaders(request)
                : request;
            return next.handle(request).pipe(operators.tap((/**
             * @param {?} response
             * @return {?}
             */
            function (response) {
                if (response instanceof http.HttpResponse) {
                    instance.interceptResponse(response);
                }
            }), (/**
             * @param {?} error
             * @return {?}
             */
            function (error) {
                instance.interceptError(error, cloneRequest);
            })));
        };
        /**
         * Retorna se, para a requisição enviada, as notificações de erro deverão ser desativadas
         */
        /**
         * Retorna se, para a requisição enviada, as notificações de erro deverão ser desativadas
         * @param {?} request
         * @return {?}
         */
        HttpInterceptorBaseService.isErrorNotificationDisabled = /**
         * Retorna se, para a requisição enviada, as notificações de erro deverão ser desativadas
         * @param {?} request
         * @return {?}
         */
        function (request) {
            /** @type {?} */
            var noErrorParam = request && request.headers.get(NO_ERROR_HEADER_PARAM);
            return noErrorParam && noErrorParam.toString().toLocaleLowerCase() === 'true';
        };
        /**
         * Clona os dados da requisição, removendo o cabeçalho 'X-Totvs-No-Error'
         */
        /**
         * Clona os dados da requisição, removendo o cabeçalho 'X-Totvs-No-Error'
         * @param {?} request
         * @return {?}
         */
        HttpInterceptorBaseService.cloneRequestWithoutErrorsHeaders = /**
         * Clona os dados da requisição, removendo o cabeçalho 'X-Totvs-No-Error'
         * @param {?} request
         * @return {?}
         */
        function (request) {
            return request && request.clone({ headers: request.headers.delete(NO_ERROR_HEADER_PARAM) });
        };
        /**
         * Recupera e formata um título vindo de um ApiTotvsErrors
         */
        /**
         * Recupera e formata um título vindo de um ApiTotvsErrors
         * @param {?} totvsError
         * @return {?}
         */
        HttpInterceptorBaseService.titleFromTotvsError = /**
         * Recupera e formata um título vindo de um ApiTotvsErrors
         * @param {?} totvsError
         * @return {?}
         */
        function (totvsError) {
            /** @type {?} */
            var title = totvsError.code ? totvsError.code : '';
            title = title ? title : totvsError.message;
            title = title ? title : 'requestFailed';
            return title + (totvsError.code && totvsError.message && totvsError.detailedMessage ? ' > ' : '');
        };
        /**
         * Recupera e formata o detalhe vindo de um ApiTotvsErrors
         */
        /**
         * Recupera e formata o detalhe vindo de um ApiTotvsErrors
         * @param {?} totvsError
         * @return {?}
         */
        HttpInterceptorBaseService.detailFromTotvsError = /**
         * Recupera e formata o detalhe vindo de um ApiTotvsErrors
         * @param {?} totvsError
         * @return {?}
         */
        function (totvsError) {
            /** @type {?} */
            var detail = totvsError.code ? totvsError.message : totvsError.detailedMessage;
            if (detail === undefined) {
                detail = totvsError.detailedMessage;
            }
            detail = HttpInterceptorBaseService.isCompleteMessage(totvsError)
                ? "mensagem:" + detail + "\ndetalhe:" + totvsError.detailedMessage
                : detail;
            if (totvsError.details && totvsError.details instanceof Array) {
                totvsError.details.forEach((/**
                 * @param {?} e
                 * @return {?}
                 */
                function (e) {
                    detail = detail.concat('\n', '-'.repeat(20), '\n', HttpInterceptorBaseService.detailFromTotvsError(e));
                }));
            }
            if (detail === undefined) {
                detail = '';
            }
            return detail;
        };
        /**
         * Retorna um objeto Message a partir de um erro totvs
         */
        /**
         * Retorna um objeto Message a partir de um erro totvs
         * @param {?} totvsError
         * @return {?}
         */
        HttpInterceptorBaseService.messageFromTotvsError = /**
         * Retorna um objeto Message a partir de um erro totvs
         * @param {?} totvsError
         * @return {?}
         */
        function (totvsError) {
            return new TextMessage({
                text: HttpInterceptorBaseService.titleFromTotvsError(totvsError),
                detailText: HttpInterceptorBaseService.detailFromTotvsError(totvsError)
            });
        };
        /**
         * Indica se ApiTotvsErrors deverá ser tratado como uma mensagem completa
         */
        /**
         * Indica se ApiTotvsErrors deverá ser tratado como uma mensagem completa
         * @param {?} e
         * @return {?}
         */
        HttpInterceptorBaseService.isCompleteMessage = /**
         * Indica se ApiTotvsErrors deverá ser tratado como uma mensagem completa
         * @param {?} e
         * @return {?}
         */
        function (e) {
            return e.code && e.message && e.detailedMessage;
        };
        /**
         * Intercepta e realiza o tratamento da requisição/retorno
         */
        /**
         * Intercepta e realiza o tratamento da requisição/retorno
         * @param {?} request
         * @param {?} next
         * @return {?}
         */
        HttpInterceptorBaseService.prototype.intercept = /**
         * Intercepta e realiza o tratamento da requisição/retorno
         * @param {?} request
         * @param {?} next
         * @return {?}
         */
        function (request, next) {
            return HttpInterceptorBaseService.defaultInterceptor(request, next, this);
        };
        return HttpInterceptorBaseService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Armazenador estático para usuário corrente
     */
    var CurrentUser = /** @class */ (function () {
        function CurrentUser() {
        }
        CurrentUser.currentUser = null;
        return CurrentUser;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Mapper que implementa o mapeamento que retorna o próprio tipo
     * @template type
     */
    var /**
     * Mapper que implementa o mapeamento que retorna o próprio tipo
     * @template type
     */
    AnyGetDtoMapper = /** @class */ (function () {
        function AnyGetDtoMapper() {
        }
        /**
         * Método que retorna o conteúdo enviado
         * @param o conteúdo enviado
         */
        /**
         * Método que retorna o conteúdo enviado
         * @param {?} content
         * @return {?}
         */
        AnyGetDtoMapper.prototype.MapTo = /**
         * Método que retorna o conteúdo enviado
         * @param {?} content
         * @return {?}
         */
        function (content) {
            return content;
        };
        return AnyGetDtoMapper;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe que mapeia a entidade que representa os usuários que serão manipulados em tela
     */
    var /**
     * Classe que mapeia a entidade que representa os usuários que serão manipulados em tela
     */
    GetAllUsersDtoMapper = /** @class */ (function () {
        function GetAllUsersDtoMapper() {
        }
        /**
         * Método que realiza o mapeamento
         * @param content Entidade de usuários recebida do RAC
         * @return DTO de usuários retornados do RAC que serão utilizado na tela base
         */
        /**
         * Método que realiza o mapeamento
         * @param {?} content Entidade de usuários recebida do RAC
         * @return {?} DTO de usuários retornados do RAC que serão utilizado na tela base
         */
        GetAllUsersDtoMapper.prototype.MapTo = /**
         * Método que realiza o mapeamento
         * @param {?} content Entidade de usuários recebida do RAC
         * @return {?} DTO de usuários retornados do RAC que serão utilizado na tela base
         */
        function (content) {
            return content;
        };
        return GetAllUsersDtoMapper;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var USER_PERMISSION_SETTINGS = new core.InjectionToken('USER_PERMISSION_SETTINGS: IUserPermissionServiceSettings Token do serviço de apoio de usuário');
    var UserPermissionService = /** @class */ (function () {
        /**
         * Método construtor da classe
         * @param settings Configurações do endpoint de permissões
         * @param httpClient Serviço Http
         */
        function UserPermissionService(receiveSettings, httpClient) {
            this.receiveSettings = receiveSettings;
            this.httpClient = httpClient;
            this.initService(this.receiveSettings);
        }
        /**
         * @param {?} queryFilter
         * @return {?}
         */
        UserPermissionService.prototype.setQueryFilter = /**
         * @param {?} queryFilter
         * @return {?}
         */
        function (queryFilter) {
            this.mappedGetAll.setQueryFilter(queryFilter);
        };
        /**
         * Método que realiza a requisição http para o endpoint de listagem de usuários
         *
         * @template IUser O tipo de dados que o enpoint retorna
         */
        /**
         * Método que realiza a requisição http para o endpoint de listagem de usuários
         *
         * @param {?=} queryFilter
         * @return {?}
         */
        UserPermissionService.prototype.getAllUsers = /**
         * Método que realiza a requisição http para o endpoint de listagem de usuários
         *
         * @param {?=} queryFilter
         * @return {?}
         */
        function (queryFilter) {
            this.mappedGetAll.setQueryFilter(queryFilter);
            return this.mappedGetAll.reset();
        };
        /**
         * Método que realiza a requisição http para o endpoint de busca de um usuário
         * @param userId Identificador do usuário
         */
        /**
         * Método que realiza a requisição http para o endpoint de busca de um usuário
         * @param {?} userId Identificador do usuário
         * @return {?}
         */
        UserPermissionService.prototype.getUser = /**
         * Método que realiza a requisição http para o endpoint de busca de um usuário
         * @param {?} userId Identificador do usuário
         * @return {?}
         */
        function (userId) {
            return this.mappedGetUser.Get(userId);
        };
        /**
         * Método que realiza a requisição http para o endpoint de busca de informações do usuário logado
         */
        /**
         * Método que realiza a requisição http para o endpoint de busca de informações do usuário logado
         * @return {?}
         */
        UserPermissionService.prototype.getUserInfo = /**
         * Método que realiza a requisição http para o endpoint de busca de informações do usuário logado
         * @return {?}
         */
        function () {
            return this.mappedGetUserInfo.Get();
        };
        /**
         * Método que permite a alteração das configurações do serviço de permissão de usuários
         * indicando URLs diferentes para os endpoints
         * @param settings Configurações
         */
        /**
         * Método que permite a alteração das configurações do serviço de permissão de usuários
         * indicando URLs diferentes para os endpoints
         * @param {?} settings Configurações
         * @return {?}
         */
        UserPermissionService.prototype.changeSettings = /**
         * Método que permite a alteração das configurações do serviço de permissão de usuários
         * indicando URLs diferentes para os endpoints
         * @param {?} settings Configurações
         * @return {?}
         */
        function (settings) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this.initService(settings);
                    return [2 /*return*/];
                });
            });
        };
        /**
         * Método que realizar a inicialização do serviço utilizando as configurações recebidas
         * @param settings Configurações
         */
        /**
         * Método que realizar a inicialização do serviço utilizando as configurações recebidas
         * @private
         * @param {?} settings Configurações
         * @return {?}
         */
        UserPermissionService.prototype.initService = /**
         * Método que realizar a inicialização do serviço utilizando as configurações recebidas
         * @private
         * @param {?} settings Configurações
         * @return {?}
         */
        function (settings) {
            this.settings = settings;
            this.mappedGetAll = new MappedGetAll(this.httpClient, this.settings.allUsersEndpoint, new ListDtoMapper(new GetAllUsersDtoMapper()));
            if (this.settings.userEndpoint) {
                this.mappedGetUser = new MappedHttpGet(this.settings.userEndpoint, new AnyGetDtoMapper(), this.httpClient);
            }
            if (this.settings.userInfoEndpoint) {
                this.mappedGetUserInfo = new MappedHttpGet(this.settings.userInfoEndpoint, new AnyGetDtoMapper(), this.httpClient);
            }
        };
        UserPermissionService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        UserPermissionService.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [USER_PERMISSION_SETTINGS,] }] },
            { type: http.HttpClient }
        ]; };
        return UserPermissionService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe utilitária para permissões do usuário
     */
    var   /**
     * Classe utilitária para permissões do usuário
     */
    UserPermission = /** @class */ (function () {
        function UserPermission() {
        }
        /**
         * Método estático responsável por adicionar a validação de permissão
         */
        /**
         * Método estático responsável por adicionar a validação de permissão
         * @param {?} user
         * @return {?}
         */
        UserPermission.AddPermissionFeatures = /**
         * Método estático responsável por adicionar a validação de permissão
         * @param {?} user
         * @return {?}
         */
        function (user) {
            /** @type {?} */
            var userWithPermissions = (/** @type {?} */ (user));
            userWithPermissions.permissions = [];
            userWithPermissions.hasPermission = this.hasPermission;
            return userWithPermissions;
        };
        /**
         * Método estático responsável por retornar se um usuário possui a permissão solicitada
         * @param this Parâmetro de extensão
         * @param permission Permissão a ser verificada
         */
        /**
         * Método estático responsável por retornar se um usuário possui a permissão solicitada
         * @this {?}
         * @param {?} permission Permissão a ser verificada
         * @return {?}
         */
        UserPermission.hasPermission = /**
         * Método estático responsável por retornar se um usuário possui a permissão solicitada
         * @this {?}
         * @param {?} permission Permissão a ser verificada
         * @return {?}
         */
        function (permission) {
            /** @type {?} */
            var permissions = this.permissions || [];
            /** @type {?} */
            var currentPermission = permissions.find((/**
             * @param {?} p
             * @return {?}
             */
            function (p) { return p.key.toLowerCase() === permission.toLowerCase(); }));
            if (currentPermission) {
                return currentPermission.value;
            }
            return false;
        };
        return UserPermission;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe do serviço de exibição de mensagem
     */
    var MessageDisplayerService = /** @class */ (function () {
        /**
         * Construtor da classe
         */
        function MessageDisplayerService(i18n, messageShower) {
            this.i18n = i18n;
            this.messageShower = messageShower;
            /**
             * Opções da mensagem
             */
            this.showMessageOptions = new ShowMessageOptions();
        }
        /** Método para exibir uma mensagem totalmente customizada  */
        /**
         * Método para exibir uma mensagem totalmente customizada
         * @param {?} showMessageOptions
         * @return {?}
         */
        MessageDisplayerService.prototype.displayMessage = /**
         * Método para exibir uma mensagem totalmente customizada
         * @param {?} showMessageOptions
         * @return {?}
         */
        function (showMessageOptions) {
            showMessageOptions = this.messageOptionsDefaults(showMessageOptions);
            this.messageShower.displayMessage(showMessageOptions);
        };
        /**
         * Método para exibir uma mensagem internacionalizada
         */
        /**
         * Método para exibir uma mensagem internacionalizada
         * @param {?} message
         * @param {?=} messageOptions
         * @return {?}
         */
        MessageDisplayerService.prototype.showMessage = /**
         * Método para exibir uma mensagem internacionalizada
         * @param {?} message
         * @param {?=} messageOptions
         * @return {?}
         */
        function (message, messageOptions) {
            if (!messageOptions || messageOptions === undefined || messageOptions == null) {
                messageOptions = new ShowMessageOptions();
            }
            if (!messageOptions.messageType || messageOptions.messageType === undefined || messageOptions.messageType == null) {
                messageOptions.messageType = message.messageType;
            }
            /** @type {?} */
            var msgI18n = this.i18n.text(message);
            messageOptions.messageText = (messageOptions.messageText &&
                messageOptions.messageText !== undefined && messageOptions.messageText.trim() !== '') ?
                messageOptions.messageText : msgI18n.text;
            messageOptions.messageDetails = (messageOptions.messageDetails &&
                messageOptions.messageDetails !== undefined && messageOptions.messageDetails.trim() !== '') ?
                messageOptions.messageDetails : msgI18n.detailText;
            messageOptions.messageTitle = msgI18n.titleText ? msgI18n.titleText.trim() : messageOptions.messageTitle;
            this.displayMessage(messageOptions);
        };
        /**
         * Método responsável por definir as opções padrões de uma mensagem
         */
        /**
         * Método responsável por definir as opções padrões de uma mensagem
         * @private
         * @param {?} msgOpts
         * @return {?}
         */
        MessageDisplayerService.prototype.messageOptionsDefaults = /**
         * Método responsável por definir as opções padrões de uma mensagem
         * @private
         * @param {?} msgOpts
         * @return {?}
         */
        function (msgOpts) {
            this.showMessageOptions.messageType = msgOpts.messageType;
            this.showMessageOptions.messageText = msgOpts.messageText;
            this.showMessageOptions.messageTitle = msgOpts.messageTitle;
            this.showMessageOptions.messageDetails = msgOpts.messageDetails;
            this.showMessageOptions.messageLinkActionType = msgOpts.messageLinkActionType ? msgOpts.messageLinkActionType :
                ShowMessageLinkActionType.No;
            this.showMessageOptions.messageLinkAction = msgOpts.messageLinkAction ? msgOpts.messageLinkAction : undefined;
            this.showMessageOptions.messageLinkLabel = msgOpts.messageLinkLabel ? msgOpts.messageLinkLabel : 'Clique aqui';
            this.showMessageOptions.messageConfirmAction = msgOpts.messageConfirmAction ? msgOpts.messageConfirmAction :
                undefined;
            this.showMessageOptions.messageConfirmLabel = msgOpts.messageConfirmLabel ? msgOpts.messageConfirmLabel : 'Ok';
            this.showMessageOptions.messageCancelAction = msgOpts.messageCancelAction ? msgOpts.messageCancelAction :
                undefined;
            this.showMessageOptions.messageCancelLabel = msgOpts.messageCancelLabel ? msgOpts.messageCancelLabel : 'Cancelar';
            return this.showMessageOptions;
        };
        MessageDisplayerService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        MessageDisplayerService.ctorParameters = function () { return [
            { type: I18nBaseService },
            { type: AbstractShowMessage }
        ]; };
        return MessageDisplayerService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DateTimeModule = /** @class */ (function () {
        function DateTimeModule() {
        }
        DateTimeModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            DateTimePipe,
                            TimePipe
                        ],
                        imports: [
                            common.CommonModule
                        ],
                        exports: [
                            DateTimePipe,
                            common.DatePipe
                        ],
                        providers: [
                            common.DatePipe,
                            DateTimePipe,
                            DefaultDateViewConverterService,
                            {
                                provide: DateViewConverter,
                                useClass: DefaultDateViewConverterService
                            },
                            TimePipe,
                            DefaultTimeViewConverterService,
                            {
                                provide: TimeViewConverter,
                                useClass: DefaultTimeViewConverterService
                            }
                        ]
                    },] }
        ];
        return DateTimeModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Dto no padrão do backend para enumeration
     */
    var   /**
     * Dto no padrão do backend para enumeration
     */
    EnumerationDto = /** @class */ (function () {
        /**
         * Método construtor que inicializa a classe
         * @param id Identificação do enumerador
         * @param name Nome apresentável do enumerador
         */
        function EnumerationDto(id, name) {
            this.id = id;
            this.name = name;
        }
        return EnumerationDto;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Cria um atributo boolean alive$ que se torna falso quando o componente for destruido
     * e um observable destroy$ que completa quando o componente for destruido.
     *
     * Exemplos de uso com observables
     * \@IsDestroyed()
     * export class MyComponent implements OnInit {
     * ...
     * timer(0, 1000).pipe(tap((x) => console.log('takeWhile', x)), takeWhile(() => this['alive$'])).subscribe();
     * timer(0, 1000).pipe(tap((x) => console.log('takeUntil', x)), takeUntil(this['destroy$'])).subscribe();
     * this['destroy$'].subscribe(() => console.log('Oh no! Somenone killed me!'));
     * }
     * @return {?}
     */
    function IsDestroyed() {
        return (/**
         * @template T
         * @param {?} constructor
         * @return {?}
         */
        function (constructor) {
            // extend constructor
            return /** @class */ (function (_super) {
                __extends(class_1, _super);
                function class_1() {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    var _this = _super.apply(this, __spread(args)) || this;
                    _this.alive$ = true;
                    _this.destroy$ = new rxjs.Subject();
                    _this.superDestroy = (/**
                     * @return {?}
                     */
                    function () { });
                    // tslint:disable-next-line:no-string-literal
                    if (_super.prototype['ngOnDestroy']) {
                        // tslint:disable-next-line:no-string-literal
                        _this.superDestroy = _super.prototype['ngOnDestroy'];
                    }
                    return _this;
                }
                /**
                 * @return {?}
                 */
                class_1.prototype.ngOnDestroy = /**
                 * @return {?}
                 */
                function () {
                    this.superDestroy();
                    this.alive$ = false;
                    this.destroy$.next();
                    this.destroy$.complete();
                };
                return class_1;
            }(constructor));
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Utilitários e funções genéricas
     */
    var   /**
     * Utilitários e funções genéricas
     */
    UtilsFn = /** @class */ (function () {
        function UtilsFn() {
        }
        /**
         * Retorna se o que foi passado é uma instância de array
         *
         * @param prop o que se deseja verificar
         * @returns se é um array ou não
         */
        /**
         * Retorna se o que foi passado é uma instância de array
         *
         * @param {?} prop o que se deseja verificar
         * @return {?} se é um array ou não
         */
        UtilsFn.isArray = /**
         * Retorna se o que foi passado é uma instância de array
         *
         * @param {?} prop o que se deseja verificar
         * @return {?} se é um array ou não
         */
        function (prop) {
            return Object.prototype.toString.call(prop) === '[object Array]';
        };
        /**
         * Em um processamento assíncrono com promises, permite que a thread aguarde o tempo informado.
         * @param ms tempo que deve aguardar, em ms
         */
        /**
         * Em um processamento assíncrono com promises, permite que a thread aguarde o tempo informado.
         * @param {?} ms tempo que deve aguardar, em ms
         * @return {?}
         */
        UtilsFn.sleep = /**
         * Em um processamento assíncrono com promises, permite que a thread aguarde o tempo informado.
         * @param {?} ms tempo que deve aguardar, em ms
         * @return {?}
         */
        function (ms) {
            /** @type {?} */
            var fn = (/**
             * @param {?} resolve
             * @return {?}
             */
            function (resolve) {
                setTimeout(resolve, ms);
            });
            return new Promise(fn);
        };
        /**
         * Lança uma rejeição com timeout caso a promise passada não seja resolvida a tempo
         * @param prom A promise que fará o processamento assíncrono
         * @param timeout O tempo que será aguardado, até um erro de timeout ocorrer
         */
        /**
         * Lança uma rejeição com timeout caso a promise passada não seja resolvida a tempo
         * @template T
         * @param {?} prom A promise que fará o processamento assíncrono
         * @param {?} timeout O tempo que será aguardado, até um erro de timeout ocorrer
         * @return {?}
         */
        UtilsFn.timeout = /**
         * Lança uma rejeição com timeout caso a promise passada não seja resolvida a tempo
         * @template T
         * @param {?} prom A promise que fará o processamento assíncrono
         * @param {?} timeout O tempo que será aguardado, até um erro de timeout ocorrer
         * @return {?}
         */
        function (prom, timeout) {
            return __awaiter(this, void 0, void 0, function () {
                var resolveFn, cancelReject, timeoutPromise, results;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            timeoutPromise = new Promise((/**
                             * @param {?} resolve
                             * @param {?} reject
                             * @return {?}
                             */
                            function (resolve, reject) {
                                cancelReject = setTimeout(reject, timeout);
                                resolveFn = resolve;
                            }));
                            return [4 /*yield*/, Promise.all([
                                    prom.then((/**
                                     * @param {?} x
                                     * @return {?}
                                     */
                                    function (x) {
                                        resolveFn(x);
                                        clearTimeout(cancelReject);
                                        return x;
                                    })),
                                    timeoutPromise,
                                ])];
                        case 1:
                            results = _a.sent();
                            return [2 /*return*/, results.shift()];
                    }
                });
            });
        };
        /**
         * Semáforo de processamento para bloqueio de concorrência em determinada sessão
         * @param fn expressão que vai ser tratada como avaliação do lock, enquanto true, continuará em bloqueio
         * @param sleepMs Quantidade, em ms, que a expressão será reavaliada em um loop infinito, até que se torne verdadeira
         */
        /**
         * Semáforo de processamento para bloqueio de concorrência em determinada sessão
         * @param {?} fn expressão que vai ser tratada como avaliação do lock, enquanto true, continuará em bloqueio
         * @param {?=} sleepMs Quantidade, em ms, que a expressão será reavaliada em um loop infinito, até que se torne verdadeira
         * @return {?}
         */
        UtilsFn.lock = /**
         * Semáforo de processamento para bloqueio de concorrência em determinada sessão
         * @param {?} fn expressão que vai ser tratada como avaliação do lock, enquanto true, continuará em bloqueio
         * @param {?=} sleepMs Quantidade, em ms, que a expressão será reavaliada em um loop infinito, até que se torne verdadeira
         * @return {?}
         */
        function (fn, sleepMs) {
            if (sleepMs === void 0) { sleepMs = 50; }
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!fn()) return [3 /*break*/, 2];
                            return [4 /*yield*/, UtilsFn.sleep(sleepMs)];
                        case 1:
                            _a.sent();
                            return [3 /*break*/, 0];
                        case 2: return [2 /*return*/];
                    }
                });
            });
        };
        return UtilsFn;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Utilitários e funções genéricas para uso em sql
     */
    var SqlUtilsFn = /** @class */ (function () {
        function SqlUtilsFn() {
        }
        /**
         * Converte os valores de um objeto para sql de inserção, separado por virgulas
         * @param obj o objeto a ser convertido
         * @param fields array de string contendo os nomes dos campos que se deseja converter
         */
        /**
         * Converte os valores de um objeto para sql de inserção, separado por virgulas
         * @param {?} obj o objeto a ser convertido
         * @param {?} fields array de string contendo os nomes dos campos que se deseja converter
         * @return {?}
         */
        SqlUtilsFn.objectToSqlstring = /**
         * Converte os valores de um objeto para sql de inserção, separado por virgulas
         * @param {?} obj o objeto a ser convertido
         * @param {?} fields array de string contendo os nomes dos campos que se deseja converter
         * @return {?}
         */
        function (obj, fields) {
            var e_1, _a;
            /** @type {?} */
            var str = '';
            /** @type {?} */
            var index = 1;
            try {
                for (var fields_1 = __values(fields), fields_1_1 = fields_1.next(); !fields_1_1.done; fields_1_1 = fields_1.next()) {
                    var prop = fields_1_1.value;
                    /** @type {?} */
                    var con = this.serialize(obj[prop]);
                    if (con !== this.DONT_SERIALIZE) {
                        str += con;
                        if (index < fields.length) {
                            str += ',';
                        }
                        index++;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (fields_1_1 && !fields_1_1.done && (_a = fields_1.return)) _a.call(fields_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return str;
        };
        /**
         * Converte os valores de um objeto para array
         * @param obj o objeto a ser convertido
         * @param fields array de string contendo os nomes dos campos que se deseja converter
         */
        /**
         * Converte os valores de um objeto para array
         * @param {?} obj o objeto a ser convertido
         * @param {?} fields array de string contendo os nomes dos campos que se deseja converter
         * @return {?}
         */
        SqlUtilsFn.objectToSqlValues = /**
         * Converte os valores de um objeto para array
         * @param {?} obj o objeto a ser convertido
         * @param {?} fields array de string contendo os nomes dos campos que se deseja converter
         * @return {?}
         */
        function (obj, fields) {
            var e_2, _a;
            /** @type {?} */
            var str = [];
            try {
                for (var fields_2 = __values(fields), fields_2_1 = fields_2.next(); !fields_2_1.done; fields_2_1 = fields_2.next()) {
                    var prop = fields_2_1.value;
                    if (this.serialize(obj[prop]) !== this.DONT_SERIALIZE) {
                        str.push(obj[prop]);
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (fields_2_1 && !fields_2_1.done && (_a = fields_2.return)) _a.call(fields_2);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return str;
        };
        /**
         * Converte o valor para um literal sql
         * @param prop a literal sql
         */
        /**
         * Converte o valor para um literal sql
         * @param {?} prop a literal sql
         * @return {?}
         */
        SqlUtilsFn.serialize = /**
         * Converte o valor para um literal sql
         * @param {?} prop a literal sql
         * @return {?}
         */
        function (prop) {
            if (UtilsFn.isArray(prop)) {
                return this.DONT_SERIALIZE;
            }
            else if (typeof prop === 'string') {
                return "'" + prop + "'";
            }
            else if (typeof prop === 'number') {
                return "" + prop;
            }
            else if (typeof prop === 'boolean') {
                return "" + (prop ? 1 : 0);
            }
            else if (typeof prop === 'undefined') {
                return "NULL";
            }
            else if (typeof prop === 'object') {
                if (prop === null || prop === undefined) {
                    return "NULL";
                }
                else if (typeof prop.toISOString === 'function') {
                    return "'" + prop.toISOString() + "'";
                }
                else {
                    return "'" + JSON.stringify(prop) + "'";
                }
            }
        };
        /**
         * Constante retornada quando um valor não pode ser serializado em banco sql
         */
        SqlUtilsFn.DONT_SERIALIZE = '[DONT_SERIALIZE]';
        return SqlUtilsFn;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Serviço fictício que representa um I18nBaseService e pode ser utilizado em módulos de testes
     */
    var   /**
     * Serviço fictício que representa um I18nBaseService e pode ser utilizado em módulos de testes
     */
    MockEmptyI18nBaseService = /** @class */ (function (_super) {
        __extends(MockEmptyI18nBaseService, _super);
        function MockEmptyI18nBaseService(loader) {
            return _super.call(this, loader) || this;
        }
        return MockEmptyI18nBaseService;
    }(I18nBaseService));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LiteralLoaderMock = /** @class */ (function () {
        function LiteralLoaderMock() {
        }
        /**
         * @param {?} literal
         * @return {?}
         */
        LiteralLoaderMock.instance = /**
         * @param {?} literal
         * @return {?}
         */
        function (literal) {
            /** @type {?} */
            var instance = jasmine.createSpyObj('ILiteralsLoader', ['load', 'updateOptions']);
            instance.load.and.returnValue(rxjs.of(literal));
            instance.updateOptions.and.returnValue(rxjs.of(literal));
            return instance;
        };
        return LiteralLoaderMock;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Button events to pass to `DebugElement.triggerEventHandler` for RouterLink event handler
     * @type {?}
     */
    var buttonClickEvents = {
        left: { button: 0 },
        right: { button: 2 }
    };
    /**
     * Simulate element click. Defaults to mouse left-button click event.
     * @param {?} el
     * @param {?=} eventObj
     * @return {?}
     */
    function click(el, eventObj) {
        if (eventObj === void 0) { eventObj = buttonClickEvents.left; }
        if (el instanceof HTMLElement) {
            el.click();
        }
        else {
            el.triggerEventHandler('click', eventObj);
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var _this = this;
    /** @type {?} */
    var configureTestSuite = (/**
     * @param {?=} configureModule
     * @return {?}
     */
    function (configureModule) { return __awaiter(_this, void 0, void 0, function () {
        var testBedApi, originReset;
        var _this = this;
        return __generator(this, function (_a) {
            testBedApi = testing.getTestBed();
            originReset = testing.TestBed.resetTestingModule;
            beforeAll((/**
             * @return {?}
             */
            function () {
                testing.TestBed.resetTestingModule();
                testing.TestBed.resetTestingModule = (/**
                 * @return {?}
                 */
                function () { return testing.TestBed; });
            }));
            if (configureModule) {
                beforeAll((/**
                 * @param {?} done
                 * @return {?}
                 */
                function (done) { return ((/**
                 * @return {?}
                 */
                function () { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                configureModule();
                                return [4 /*yield*/, testing.TestBed.compileComponents()];
                            case 1:
                                _a.sent();
                                return [2 /*return*/];
                        }
                    });
                }); }))().then(done).catch(done.fail); }));
            }
            afterEach((/**
             * @return {?}
             */
            function () {
                testBedApi._activeFixtures.forEach((/**
                 * @param {?} fixture
                 * @return {?}
                 */
                function (fixture) { return fixture.destroy(); }));
                testBedApi._instantiated = false;
            }));
            afterAll((/**
             * @return {?}
             */
            function () {
                testing.TestBed.resetTestingModule = originReset;
                testing.TestBed.resetTestingModule();
            }));
            return [2 /*return*/];
        });
    }); });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @return {?}
     */
    function spyOnLocalStorage() {
        /** @type {?} */
        var store = {};
        spyOn(localStorage, 'getItem').and.callFake((/**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            return store[key] || null;
        }));
        spyOn(localStorage, 'removeItem').and.callFake((/**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            delete store[key];
        }));
        spyOn(localStorage, 'setItem').and.callFake((/**
         * @param {?} key
         * @param {?} value
         * @return {?}
         */
        function (key, value) {
            return store[key] = (/** @type {?} */ (value));
        }));
        spyOn(localStorage, 'clear').and.callFake((/**
         * @return {?}
         */
        function () {
            store = {};
        }));
    }

    exports.AUTH_SETTINGS = AUTH_SETTINGS;
    exports.AUTH_TYPE = AUTH_TYPE;
    exports.AbstractShowMessage = AbstractShowMessage;
    exports.ApiDateTimeConstants = ApiDateTimeConstants;
    exports.ApiDateTimeService = ApiDateTimeService;
    exports.ApiFilter = ApiFilter;
    exports.ApiOrderField = ApiOrderField;
    exports.ApiOrderType = ApiOrderType;
    exports.ApiQueryString = ApiQueryString;
    exports.AuthBaseService = AuthBaseService;
    exports.AuthHandlerType = AuthHandlerType;
    exports.AuthInterceptorHandlerService = AuthInterceptorHandlerService;
    exports.BaseMessage = BaseMessage;
    exports.CriticalError = CriticalError;
    exports.CurrentUser = CurrentUser;
    exports.DateTimeModule = DateTimeModule;
    exports.DateTimePipe = DateTimePipe;
    exports.DateViewConverter = DateViewConverter;
    exports.DefaultDateViewConverterService = DefaultDateViewConverterService;
    exports.DefaultResponseDto = DefaultResponseDto;
    exports.DefaultTimeViewConverterService = DefaultTimeViewConverterService;
    exports.EOData = EOData;
    exports.EnumerationDto = EnumerationDto;
    exports.FieldValue = FieldValue;
    exports.FormUtils = FormUtils;
    exports.FormUtilsWithService = FormUtilsWithService;
    exports.HttpInterceptorBaseService = HttpInterceptorBaseService;
    exports.I18nBaseService = I18nBaseService;
    exports.IsDestroyed = IsDestroyed;
    exports.ListDto = ListDto;
    exports.ListDtoMapper = ListDtoMapper;
    exports.LiteralLoaderMock = LiteralLoaderMock;
    exports.LoadingDefault = LoadingDefault;
    exports.MappedGetAll = MappedGetAll;
    exports.MappedHttp = MappedHttp;
    exports.MappedHttpDelete = MappedHttpDelete;
    exports.MappedHttpGet = MappedHttpGet;
    exports.MappedHttpGetWithQueryFilter = MappedHttpGetWithQueryFilter;
    exports.MappedHttpGetWithQueryString = MappedHttpGetWithQueryString;
    exports.MappedHttpPost = MappedHttpPost;
    exports.MappedHttpPostLocation = MappedHttpPostLocation;
    exports.MappedHttpPut = MappedHttpPut;
    exports.MessageDisplayerService = MessageDisplayerService;
    exports.MessageType = MessageType;
    exports.MessageUtils = MessageUtils;
    exports.MockEmptyI18nBaseService = MockEmptyI18nBaseService;
    exports.NO_ERROR_HEADER_PARAM = NO_ERROR_HEADER_PARAM;
    exports.OData = OData;
    exports.ODataAnd = ODataAnd;
    exports.ODataNot = ODataNot;
    exports.ODataOr = ODataOr;
    exports.QueryFilter = QueryFilter;
    exports.ShowMessageLinkActionType = ShowMessageLinkActionType;
    exports.ShowMessageOptions = ShowMessageOptions;
    exports.ShowMessageType = ShowMessageType;
    exports.SqlUtilsFn = SqlUtilsFn;
    exports.TextMessage = TextMessage;
    exports.TimePipe = TimePipe;
    exports.TimeViewConverter = TimeViewConverter;
    exports.TotvsMessageType = TotvsMessageType;
    exports.USER_PERMISSION_SETTINGS = USER_PERMISSION_SETTINGS;
    exports.UrlMapper = UrlMapper;
    exports.UrlUtils = UrlUtils;
    exports.UserPermission = UserPermission;
    exports.UserPermissionService = UserPermissionService;
    exports.UtilsFn = UtilsFn;
    exports.buttonClickEvents = buttonClickEvents;
    exports.click = click;
    exports.configureTestSuite = configureTestSuite;
    exports.spyOnLocalStorage = spyOnLocalStorage;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=totvs-log-base-foundation.umd.js.map
