import { IEnumeration } from './enumeration.interface';
/**
 * Dto no padrão do backend para enumeration
 */
export declare class EnumerationDto implements IEnumeration {
    /**
     * Identificação do enumerador
     */
    readonly id: number;
    /**
     * Nome apresentável do enumerador
     */
    readonly name: string;
    /**
     * Método construtor que inicializa a classe
     * @param id Identificação do enumerador
     * @param name Nome apresentável do enumerador
     */
    constructor(id: number, name: string);
}
