/**
 * Classe com as constantes definidas de data e hora
 */
export declare class ApiDateTimeConstants {
    /** formato de data padrão */
    static readonly DATE_FORMAT = "yyyy-MM-dd";
    /** formato de exibição de data em português */
    static readonly DATE_FORMAT_DISPLAY_PT = "dd/MM/yyyy";
    /** formato de exibição de data em inglês */
    static readonly DATE_FORMAT_DISPLAY_EN = "MM/dd/yyyy";
    /** formato de exibição padrão de hora, minuto e segundo */
    static readonly TIME_FORMAT = "HH:mm:ss";
    /** formato de exibição padrão de fuso horário */
    static readonly TIMEZONE_FORMAT = "ZZZZZ";
    /** Linguagem padrão */
    static readonly LANG_DEFAULT = "en-US";
}
