import { IOData } from './o-data.interface';
/**
 * Responsável por montar os filtros baseados em odata, atendendo ao guia de api totvs
 */
export interface IApiFilter extends IOData {
    /**
     * Contagem dos filtros que foram adicionados
     */
    length: number;
    /**
     * Adiciona um filtro que atende a conversão para string
     */
    add(...odata: Array<IOData>): void;
    /**
     * Agrupa um grupo lógico adicionado, no próximo grupo ou no grupo recém adicionado
     */
    addGroup(previous: boolean): void;
}
