import { IMapper } from './../mappers/mapper.interface';
/**
 * Classe abstrata para possuir um mapper de url por padrão
 */
export declare abstract class MappedHttp {
    protected urlMapper: IMapper<Array<any>, string>;
    /**
     * @param urlMapper Um mapper que implementa um mapeamento de parâmetros para url
     */
    constructor(urlMapper: IMapper<Array<any>, string>);
}
