import { EOData } from './o-data.enum';
import { IBaseOData } from './o-data-base.interface';
/**
 * Classe que representa o operador odata and
 * Deve ser apenas instanciado pelo Odata.And()
 */
export declare class ODataAnd implements IBaseOData {
    private left;
    private right;
    /**
     * Operador lógico &&
     */
    operator: EOData;
    /**
     * Construtor
     */
    constructor(left: IBaseOData, right: IBaseOData);
    /**
     * Retorna a string Odata
     */
    toString(): string;
}
