import { IOData } from './o-data.interface';
import { EOData } from './o-data.enum';
/**
 * Interface base para OData
 */
export interface IBaseOData extends IOData {
    /**
     * campo para filtro
     */
    field?: string;
    /**
     * valor solicitado para filtro
     */
    value?: string | number | IOData;
    /**
     * operação que irá definir o tipo de filtro
     */
    operator: EOData;
}
