import { FormGroup } from '@angular/forms';
import { IFormUtils } from './form-utils.interface';
/**
 * Utilitários para formulários
 */
export declare class FormUtils implements IFormUtils {
    private form;
    /**
     * Implementação para verificar se o formulário possui algum controle alterado
     */
    isFormChanged(): boolean;
    private getControls;
    /**
     * Implementação para marcar o formulário como não mechido pelo usuário
     */
    markFormPristine(): void;
    /**
     * Implementação para verificar a validade do formulário como um todo e marcar os campos inválidos
     */
    executeFormValidation(): boolean;
    /**
     * Retorna o form relacionado;
     */
    getForm(): FormGroup;
    constructor(form: FormGroup);
}
