import { FormGroup } from '@angular/forms';
/**
 * Interface para utilitários do formulário
 */
export interface IFormUtils {
    /**
     * Implementação para verificar se o formulário possui algum controle alterado
     */
    isFormChanged(): boolean;
    /**
     * Implementação para marcar o formulário como não mechido pelo usuário
     */
    markFormPristine(): void;
    /**
     * Implementação para verificar a validade do formulário como um todo e marcar os campos inválidos
     */
    executeFormValidation(): boolean;
    /**
     * Retorna o form relacionado;
     */
    getForm(): FormGroup;
}
