import { PipeTransform } from '@angular/core';
import { TimeViewConverter } from '../../services/view-converter/time-view-converter';
import { I18nBaseService } from '../../entities/i18n/i18n-base-service';
/**
 * Classe/pipe para aplicação de transformação em um objeto data
 */
export declare class TimePipe implements PipeTransform {
    private timeViewConverter;
    private i18n;
    /**
     * Método construtor da classe
     */
    constructor(timeViewConverter: TimeViewConverter, i18n: I18nBaseService);
    /**
     * Método padrão para aplicação do Pipe
     * @param value recebe o objeto que contém as informações
     * @param format  recebe as informações de formato
     */
    transform(value: any, format: string): string;
}
