import { IMapper } from '../../../../entities/api-tools/mappers/mapper.interface';
/**
 * Mapper que implementa o mapeamento que retorna o próprio tipo
 */
export declare class AnyGetDtoMapper<type> implements IMapper<type, type> {
    /**
     * Método que retorna o conteúdo enviado
     * @param o conteúdo enviado
     */
    MapTo(content: type): type;
}
