/**
 * Interface simplificada para representar o usuário do tnf
 */
export interface ITnfUser {
    /**
     * ID
     */
    id: number;
    /**
     * Id do inquilino
     */
    tenantId: number;
    /**
     * Nome do inquilino
     */
    tenantName: string;
    /**
     * o id externo do usuario (ex. paulo.silva)
     */
    userName: string;
    /**
     * O nome do usuário (ex. Paulo)
     */
    name: string;
    /**
     * O nome completo do usuário (ex. Paulo Silva)
     */
    fullName: string;
    /**
     * O endereço de e-mail do usuário
     */
    emailAddress: string;
}
