import { DatePipe } from '@angular/common';
import { DateViewConverter } from './date-view-converter';
/**
 * Classe padrão do serviço de conversão e exibição de data
 */
export declare class DefaultDateViewConverterService extends DateViewConverter {
    protected transformer: DatePipe;
    /**
     * Método construtor da classe
     */
    constructor(transformer: DatePipe);
    /**
     * Método responsável pela visualização do valor formatado
     */
    toView(value: any, format?: string): string;
}
