import { PipeTransform } from '@angular/core';
import { IViewConverter } from './view-converter.interface';
/**
 * Classe abstrata de conversor e exibição de Hora
 */
export declare abstract class TimeViewConverter implements IViewConverter {
    protected transformer: PipeTransform;
    /** Linguagem */
    language: string;
    /**
     * Construtor da classe
     */
    constructor(transformer: PipeTransform);
    /** Visualização do valor formatado */
    abstract toView(value: any, format?: string): string;
}
