import { ISyncItemDto } from './sync-item.dto';
/**
 * Interface da resposta padrão para sincronismo offline
 */
export interface IDefaultSyncResponseDto<T extends ISyncItemDto> {
    /**
     * Versão atual dos registros da tabela
     */
    entityVersion: string;
    /**
     * A diferença de items para a versão informada
     */
    items: T[];
    /**
     * Se há mais registros
     */
    hasNext: boolean;
}
