import { IMapper } from './../mappers/mapper.interface';
import { IListDto } from './list-dto.interface';
/**
 * Mapper padrão para Dto
 */
export declare class ListDtoMapper<In, Out> implements IMapper<IListDto<In>, IListDto<Out>> {
    private itemMapper;
    /**
     * Efetua o mapeando da lista de entidades
     * @param content Conteúdo do backend
     */
    MapTo(content: IListDto<In>): IListDto<Out>;
    constructor(itemMapper: IMapper<In, Out>);
}
