import { IListDto } from './list-dto.interface';
/**
 * Implementação da lista padrão de Dto
 * @template Dto Objeto que representa um item
 */
export declare class ListDto<Dto> implements IListDto<Dto> {
    /**
     * Indica se ainda existem mais itens no servidor
     */
    hasNext: boolean;
    /**
     * A própria lista de itens
     */
    items: Dto[];
}
