import { IOData } from './o-data.interface';
import { IFieldValue } from './field-value.interface';
/**
 * Classe que representa um chave/valor
 */
export declare class FieldValue implements IFieldValue {
    /**
     * campo para filtro
     */
    field: string;
    /**
     * valor solicitado para filtro
     */
    value: string | number | IOData;
    constructor(field: string, value: string | number | IOData);
}
