/**
 * Interface para consulta que possibilite definir as expansões
 */
export interface IGetAllExpand {
    /**
     * Expansões para a consulta
     */
    expands: string[];
    /**
     * Método responsável por definir as expansões para a consulta
     * @param expands Lista de expansões
     */
    setExpands(...expands: string[]): void;
}
