import { IQueryFilter } from './../query-filter.interface';
/**
 * Interface para consulta que possibilite filtros
 */
export interface IGetAllQueryFilter {
    /**
     * Método responsável por definir os filtros por query que devem ser aplicados a consulta
     * @param queryFilter Classe que contém a definição dos filtros
     */
    setQueryFilter(queryFilter: IQueryFilter): void;
}
