import { Observable } from 'rxjs';
/**
 * Interface para um serviço que contenha uma chamada rest de leitura de um recurso
 *
 * @template Out Entidade que será devolvida na leitura
 */
export interface IGetEntity<Out> {
    /**
     * Implementação da chamada de leitura de um recurso
     */
    Get(...params: Array<any>): Observable<Out>;
}
