import { II18nBaseLanguage } from './i18n-base-language.interface';
/**
 * Interface base das opções de internacionalização
 */
export interface II18nBaseOptions {
    /** Idioma a ser buscado */
    language: string;
    /** Url dos assets */
    url: string;
    /**
     * Idiomas suportados pela aplicação
     */
    supportedLanguages?: Array<II18nBaseLanguage>;
}
