import { II18nBaseLanguage } from './i18n-base-language.interface';
/**
 * Interface para as opções de internacionalização
 */
export interface II18nUpdateOptions {
    /** Atributo Contexto */
    context?: string;
    /** Atributo Linguagem */
    language?: string;
    /** Atributo Url */
    url?: string;
    /** Idiomas suportados pela aplicação */
    supportedLanguages?: Array<II18nBaseLanguage>;
}
