import { PipeTransform } from '@angular/core';
import { DateViewConverter } from './../../services/view-converter/date-view-converter';
import { I18nBaseService } from './../../entities/i18n/i18n-base-service';
/**
 * Classe/pipe para aplicação de transformação em um objeto data
 */
export declare class DateTimePipe implements PipeTransform {
    private dateViewConverter;
    private i18n;
    /**
     * Método construtor da clase
     */
    constructor(dateViewConverter: DateViewConverter, i18n: I18nBaseService);
    /**
     * Método padrão para aplicação do Pipe
     * @param value recebe o objeto que contém as informações
     * @param format  recebe as informações de formato
     */
    transform(value: any, format: string): string;
}
