import { IMapper } from './../../../../entities/api-tools/mappers/mapper.interface';
import { ITnfUser } from '../tnf/tnf.index';
/**
 * Classe que mapeia a entidade que representa os usuários que serão manipulados em tela
 */
export declare class GetAllUsersDtoMapper implements IMapper<ITnfUser, ITnfUser> {
    /**
     * Método que realiza o mapeamento
     * @param content Entidade de usuários recebida do RAC
     * @return DTO de usuários retornados do RAC que serão utilizado na tela base
     */
    MapTo(content: ITnfUser): ITnfUser;
}
