import { User } from 'oidc-client';
import { IUserWithPermission } from './user-with-permission.interface';
/**
 * Classe utilitária para permissões do usuário
 */
export declare class UserPermission {
    /**
     * Método estático responsável por adicionar a validação de permissão
     */
    static AddPermissionFeatures(user: User): IUserWithPermission;
    /**
     * Método estático responsável por retornar se um usuário possui a permissão solicitada
     * @param this Parâmetro de extensão
     * @param permission Permissão a ser verificada
     */
    static hasPermission(this: IUserWithPermission, permission: string): boolean;
}
