import { IAuthHandlerType } from './auth-handler-type.interface';
import { HttpRequest, HttpHandler, HttpEvent, HttpInterceptor } from '@angular/common/http';
import { AuthBaseService } from './../../auth/auth-base-service';
import { Observable } from 'rxjs';
export declare class AuthInterceptorHandlerService implements HttpInterceptor {
    private auth;
    private authType;
    /**
     * Creates an instance of AuthInterceptorHandlerService.
     */
    constructor(auth: AuthBaseService, authType: IAuthHandlerType);
    /**
     * Implementação da interface de interceptação HTTP
     * que apenas adiciona ao cabeçalho da requisição o token.
     */
    intercept(request: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>>;
}
