import { HttpInterceptor, HttpRequest, HttpResponse, HttpErrorResponse } from '@angular/common/http';
/**
 * Interface que deve ser implementada para atender interceptadores de mensagem http
 */
export interface IHttpInterceptor extends HttpInterceptor {
    /**
     * Implementar o tratamento de respostas de sucesso
     */
    interceptResponse(response: HttpResponse<any>): any;
    /**
     * Implementar o tratamento de respostas de erro
     */
    interceptError(response: HttpErrorResponse, request: HttpRequest<any>): any;
}
