import { DatePipe } from '@angular/common';
import { TimeViewConverter } from './time-view-converter';
/**
 * Classe padrão do serviço de conversão e exibição de Hora
 */
export declare class DefaultTimeViewConverterService extends TimeViewConverter {
    protected transformer: DatePipe;
    /**
     * Contrutor da classe
     */
    constructor(transformer: DatePipe);
    /**
     * Método responsável pela visualização da hora formatada
     */
    toView(value: any, format?: string): string;
}
